 /*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */
 
 
#include "display/Ega_Font.h"


Ega_Font::Ega_Font(char * FontFileName)
{
	font_tex = new Ega_Texture( FontFileName );
	font_color = Vect4(1.0, 1.0, 1.0, 1.0);
	
	CreateFont();
}

Ega_Font::~Ega_Font()
{

}

void Ega_Font::setColor(Vect4 color)
{
    font_color = color;
}

void Ega_Font::CreateFont()
{
	int iLargeur, iHauteur;

	// On cr 256 display lists, une par caractre.
	font_displaylist = glGenLists (256);
	for (int i = 0; i < 256; i++)
	{
		float fTexCoordX = float (i%16) / 16.0f;
		float fTexCoordY = float (i/16) / 16.0f;

		// Indique le contenu des listes d'affichages
		glNewList (font_displaylist + i, GL_COMPILE);
			// Liste des commandes qui seront excuts par la liste d'affichage

			// Indique la texture que l'on souhait utiliser
		font_tex->applyTexture();
			// Affiche un quadrangle comme fragment de la texture c'est  dire restreint  un caractre
			glBegin (GL_QUADS);
				// Indique les coordonnes de la texture pour le vertex bas gauche
				glTexCoord2f (fTexCoordX, 1.0f - fTexCoordY - 0.0625f);
				glVertex2f (0.0, 0.0);
				
				// Indique les coordonnes de la texture pour le vertex bas droit
				glTexCoord2f (fTexCoordX + 0.0625f, 1.0f - fTexCoordY - 0.0625f); // (0.0625 = 1 / 16)
				glVertex2d ( 10.0, 0.0);
				
				// Indique les coordonnes de la texture pour le vertex haut droit
				glTexCoord2f (fTexCoordX + 0.0625f, 1.0f - fTexCoordY);
				glVertex2d ( 10.0, 10.0);
				
				// Indique les coordonnes de la texture pour le vertex haut gauche
				glTexCoord2f (fTexCoordX, 1.0f - fTexCoordY);
				glVertex2d (0.0, 10.0);
			glEnd ();
			glTranslatef(10.0, 0.0, 0.0);
		glEndList ();
	}
}

void Ega_Font::print(int _x, int _y, const char *Text)
{
	/*char szText[256];
	va_list ap;

	//memset(szText, '\0', 256);

	if (_szMsg == 0)
		return;

	// Analyse la chane format et place le rsultat dans szText
	va_start(ap, _szMsg);
	    vsprintf(szText, _szMsg, ap);
	va_end(ap);*/

	if ( Text == 0 )
		return;

	glDisable(GL_LIGHTING);
	// On active l'utilisation des textures.
	glEnable(GL_TEXTURE_2D);
	// On active la transparence.
	glEnable (GL_BLEND);
    //definie le mode de transparence, la transparence est ralise par la couche alpha.
	//glBlendFunc(GL_ONE, GL_ONE);GL_ONE_MINUS_SRC_ALPHA
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);

	glColor3f(font_color[0], font_color[1], font_color[2]);
	glMatrixMode(GL_MODELVIEW);
	
	glPushAttrib(GL_TEXTURE_BIT || GL_LIST_BIT);
	glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);	
	
	glPushMatrix();
		glLoadIdentity();
        glTranslatef( float(_x) , FENETRE_HAUTEUR - float(_y) , 0.0 );
		glListBase(font_displaylist);

		// Excute chaque liste d'affichages, chaque charactre tant l'identifiant d'une liste d'affichages.
		glCallLists( strlen(Text), GL_UNSIGNED_BYTE, Text);
	glPopMatrix ();
	glPopAttrib();
	
	// On deactive la transparence
	glDisable (GL_BLEND);
	// On deactive l'utilisation des textures.
	glDisable (GL_TEXTURE_2D);
	
}
