/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video VaccumBlast
 * developpe au sein du club ENSI-GAME-ART
 */


/**
 * EGA_Font permet l'affichage de texte sur l'cran.
 * EGA_Font charge un fichier de font(image) et affiche les caracteres 
 * o il faut pour que ce soit devant la camra.
 * Utilise la classe Ega_Texture et Ega_vect4
 *
 * @author	Gautier Matthieu
 * @see Ega_Texture
 * @see Ega_vect4
 */

#ifndef _EGA_FONT_H_
#define _EGA_FONT_H_

#include <string.h>
#include <stdarg.h>
#include "tool/Ega_Vecteur.h"
#include "display/Ega_Texture.h"
#include "other/Ega_Global_Params.h"


class Ega_Font  
{
private:
	
	unsigned int font_displaylist;
	Vect4 font_color;
	Ega_Texture *font_tex;

public:
    /*
     * Construit la classe a partir d'un fichier
     * @param FontFileName chemin du fichier image
     */
    Ega_Font(char* FontFileName);
    
    /*
     * Detruit la classe
     */
	virtual ~Ega_Font();    
    
    /*
     * Affiche un texte a l'ecran
     * @param _x coordonne horizontalle du texte ( en pixel )
     * @param _y coordonne verticalle du texte ( en pixel )
     * @param szMsg chaine de caractere a afficher
     */
	void print(int _x, int _y, const char *szMsg);
	
	/*
	 * Creer les fonts a partir d'une image
	 */
	void CreateFont();
	
	/*
	 * spcifie la couleur de la font
	 * @param color nouvelle couleur de la font (avec l'alpha)
	 */
	void setColor(Vect4 color);
	
};

#endif
