 /*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */

#include "engine/Ega_Scene.h"
#include "display/Ega_Object.h"
#include "other/Ega_debug.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Ega_Object::Ega_Object()
{
	position = Vect3(0.0, 0.0, 0.0);
	scale = Vect3(1.0, 1.0, 1.0);
	orientation = quaternion(0.0,Vect3( 0.0, 1.0, 0.0));
}

Ega_Object::~Ega_Object()
{

}

void Ega_Object::draw()
{
	//if (!Ega_Scene::getIt()->getMaterial(matId)->getDiffTex()->isTransparent()){
    PRINT_DISPLAY2("begin object draw material: %d\n", matId);
    //Ega_Scene::getIt()->applyMaterial(matId);
	
    
    glPushMatrix();
    
     glTranslatef( position[0], position[1], position[2]);
     
     Vect3 axis = orientation.getAxis();
     glRotatef( orientation.getAngle(), axis[0], axis[1], axis[2] );     
    
	 PRINT_DISPLAY2("scale object %d\n",scale[0]);
	 PRINT_DISPLAY2("             %d\n",scale[1]);
	 PRINT_DISPLAY2("             %d\n",scale[2]);
     glScaled( scale[0], scale[1], scale[2]);     
     
     PRINT_DISPLAY2("begin object draw DL: %d\n", Id);
	 glCallList(Id);
	 
	glPopMatrix();
	
	//Ega_Scene::getIt()->resetMaterial(matId);
	PRINT_DISPLAY1("after object draw\n");
	//}
}
