 /*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */

#ifndef _EGA_OBJECT_H_
#define _EGA_OBJECT_H_

#include "tool/Ega_Tools.h"
#include <gl/gl.h>

/* Vcb_Object is the Class for the graphical representation of any entity.
 * Vcb_Object create a display list on openGl and call her when needing to be draw
 *
 * @author Matthieu Gautier
 * @author Pierre Leduc
 */
class Ega_Object  
{

	friend class Ega_ObjectParser;
public:
    
	Ega_Object();
	virtual ~Ega_Object();
	
	//void setName(string _name) { obj_name = _name;};
	//void setMode(GLenum _mode) { obj_mode = _mode;};
	void setDisplayList(GLuint _Id) { Id =  _Id;};
	void setMaterialID(GLuint _matId) { matId =  _matId;};
	
	virtual void draw();
	
	virtual void setPosition(Vect3 pos){ position = pos;}
	virtual void setScale(Vect3 scal){ scale = scal;}
	void setOrientAxis(Vect3 axe){ orientation.setAxis(axe);}
	void setOrientAngle(float angl){ orientation.setAngle(angl);}
	virtual void setOrientation(quaternion orient){ orientation = orient; } 
	
	Vect3 getPosition(){ return position;}
	Vect3 getScale(){ return scale;}
	quaternion getOrientation(){ return orientation;}
	
	void activPosAnim(){ bPosAnim = true; }
	void activRotAnim(){ bRotAnim = true; }
	void activScalAnim(){ bScalAnim = true; }
	
	bool isPosAnim(){ return bPosAnim; }
	bool isRotAnim(){ return bRotAnim; }
	bool isScalAnim(){ return bScalAnim; }
	
protected:
    Vect3 position;
    Vect3 scale;
    quaternion orientation;
    
   	bool bPosAnim;
   	bool bRotAnim;
   	bool bScalAnim;
	//vector<animation> *obj_animtrack;
    
    //string obj_name;
    //GLenum obj_mode;
    GLuint Id;
   	GLuint matId;

};

#endif
