/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */
 
#include "display/Ega_Sprite.h"


Ega_Sprite::Ega_Sprite( char *Filename, char *Maskname, Ega_Camera *cam, int wdiv, int hdiv, float size)
{
    spr_tex = new Ega_Texture( Filename,Maskname );
    spr_pixbyspr = int(float(spr_tex->getWidth()) / float(wdiv));
	spr_size = size;
	spr_wdiv = wdiv;
	spr_hdiv = hdiv;
	spr_speed = 0.35;
	spr_play = 1.0;
	
	spr_w = 1;
	spr_h = 1;	
	
	//SPRlog = fopen("SPRlog.txt", "wt");
	

	spr_cam = cam;
}

Ega_Sprite :: ~Ega_Sprite()
{
	;
}

void Ega_Sprite :: Replay()
{
    spr_w = 1;
    spr_h = 1;
    spr_play = 1.5;
}


void Ega_Sprite :: DefinirCamera(Ega_Camera * cam)
{
	spr_cam = cam;
}


void Ega_Sprite::UpdateSPR()
{
	if( (spr_play >= float(spr_w+1)) && !(spr_w >= spr_wdiv+1))
	     {     spr_w+=1;      }
    
	     
	if( spr_w >= spr_wdiv+1 )	 
    {	    
	     spr_w = 1; 
	     spr_play = 1.5;
	     if(spr_h >= spr_hdiv)  {	 
               spr_h = 1;       
               }
         else{
               spr_h+=1; }
    }
    else
    {
        spr_play+=spr_speed;
    } 	     
    //fprintf( SPRlog, "SPRw = %d; SPRh = %d; SPRplay = %f; \n", SPRw, SPRh, SPRplay);    
    
    BaseCoordU = float((spr_w-1)*spr_pixbyspr) / float(spr_wdiv*spr_pixbyspr);
	BaseCoordV = float((spr_hdiv-spr_h)*spr_pixbyspr) / float(spr_hdiv*spr_pixbyspr);
	
	EndCoordU = float((spr_w-1)*spr_pixbyspr + spr_pixbyspr) / float(spr_wdiv*spr_pixbyspr);
	EndCoordV = float((spr_hdiv-spr_h)*spr_pixbyspr + spr_pixbyspr) / float(spr_hdiv*spr_pixbyspr);
	     
 /*   float camx, camy, camz;
   	SPRcam->PositionCamera(camx,camy,camz);
    
    float camNormXY = sqrt(camx*camx + camy*camy);
    float camNormYZ = sqrt(camy*camy + camz*camz);
    float camNormXZ = sqrt(camx*camx + camz*camz);
    
	SPRrotx = acos(camz/camNormYZ)/6.28;
	SPRroty = acos(camx/camNormXZ)/6.28;
	SPRrotz = acos(camx/camNormXY)/6.28;*/
	
}


void Ega_Sprite :: Afficher()
{
    UpdateSPR();	
	
	glEnable(GL_TEXTURE_2D);
	
	glPushAttrib(GL_TEXTURE_BIT);
	glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
	glColor4f(1.0, 1.0, 1.0, 1.0);
	glEnable(GL_BLEND);									// Enable Blending
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	
	spr_tex->applyTexture();
	
	glPushMatrix();	
	//glRotatef(180.0, SPRrotx, SPRroty, SPRrotz);
	
	glBegin(GL_QUADS);
		glTexCoord2f(BaseCoordU,BaseCoordV);        
        glVertex3f(-spr_size/2,-spr_size/2,0.0);
	
     	glTexCoord2f(EndCoordU,BaseCoordV);      
        glVertex3f(spr_size/2,-spr_size/2,0.0);
        
		glTexCoord2f(EndCoordU,EndCoordV);                            
        glVertex3f(spr_size/2,spr_size/2,0.0);
        
		glTexCoord2f(BaseCoordU,EndCoordV);                         
        glVertex3f(-spr_size/2.0,spr_size/2.0,0.0);
	glEnd();

	glPopMatrix();	
	glPopAttrib();
	
	glDisable(GL_BLEND);
 
  	spr_tex->resetTexture();	
	
	glDisable(GL_TEXTURE_2D);

}

