/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */

#ifndef _EGA_SPRITE_H_
#define _EGA_SPRITE_H_

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "other/Ega_Camera.h"
#include "display/Ega_Texture.h"

/**
 * Draw image on the plan of the camera.
 *
 * @author	Pierre Leduc
 */
class Ega_Sprite
{
    
private:
	float spr_size;
    int spr_wdiv;
    int spr_hdiv;
    int spr_w;	
    int spr_h;	
    int spr_pixbyspr;
    
    float spr_speed;	
    float spr_play;		
    FILE *spr_log;
    
    float BaseCoordU;
	float BaseCoordV;	
	float EndCoordU;
	float EndCoordV;
	
	float spr_rotx;
	float spr_roty;
	float spr_rotz;
	
	Ega_Texture * spr_tex;		        
	Ega_Camera *  spr_cam;			
	
	void UpdateSPR();
	
public:
	Ega_Sprite( char *Filename, char *Maskname, Ega_Camera *cam, int wdiv, int hdiv, float size);
	~Ega_Sprite();
	
	void DefinirCamera(Ega_Camera *cam);
	void Afficher();
	void Replay();

};

#endif
