/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */

#ifndef _EGA_TEXTURE_H_
#define _EGA_TEXTURE_H_

#include <stdlib.h>
#include <stdio.h>

#include <gl/gl.h>
#include <gl/glu.h>

#include <SDL.h>
#include <SDL_image.h>

#define RGB_  0
#define RGBA_ 1

/**
 * "interface" to manage texture.
 *
 * @author	Pierre Leduc
 */
class Ega_Texture
{
private:
    GLuint      tex_id;					    // ID de la texture
	char *		tex_filename;				// fichier .BMP
	int			tex_height;					// hauteur de l'image
	int			tex_width;					// largeur de l'image
	int			tex_depth;					// nombre de bits par pixels
	bool		tex_cree ;					// texture cre ?
	unsigned char * tex_pixels;			    // tableau de donnes
	
	bool        tex_isTransparent;
	
    SDL_Surface *tex_image;
    SDL_Surface *tex_mask;

public:
    Ega_Texture( );
    Ega_Texture( char *Filename );
	Ega_Texture( char *Filename, char * Maskname );								// constructeur
	virtual ~Ega_Texture();								// destructeur
    
	void applyTexture();				// permet d'appliquer la texture aux objets suivants
	void resetTexture();
	GLuint  loadTexture( char *Filename, char *Maskname );
	GLuint  loadTexture( char *Filename );

	GLuint getID();
	int getWidth();
	int getHeight();
	int getDepth();
	bool isTransparent();
};

#endif
