/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */

#include "engine/Ega_Scene.h"
#include "Ega_Collide.h"

Ega_Collide::Ega_Collide()
{
    col_vectorCollision.clear();
}    

Ega_Collide::~Ega_Collide()
{
}
    
void Ega_Collide::testCollision()
{
    dContactGeom _contactgeom[POINT_CONTACT];
    collision _collision;
    int result;
    
    while( col_vectorCollision.size() )
    	col_vectorCollision.pop_back();
    	
    for (int i=0 ; i<Ega_Scene::getIt()->getNbEntity() ; i++)
    {
        Ega_Entity *_entite1 = Ega_Scene::getIt()->getEntity(i);
        if ( _entite1->isPhysic() )
        {
            _collision._contact[0].depth = (_entite1->getPosition().norme() - Ega_Scene::getIt()->getRadiusWorld());
            if ( _collision._contact[0].depth>0 )
            {
                _collision._contact[0].pos = _entite1->getPosition();
                _collision._contact[0].normal = -_entite1->getPosition().normalized();
                _collision.Id1 = i; _collision.Id2 = -1;
                _collision.vit1 = _entite1->getSpeed(); _collision.vit2 = Vect3(0,0,0);
                _collision.pos1 = _entite1->getPosition(); _collision.pos2 = Vect3(0,0,0);
                _collision.rot1 = _entite1->getAngularSpeed(); _collision.rot2 = quaternion(0.0,Vect3(0,0,0));
                _collision.nbContact = 1;
                col_vectorCollision.push_back(_collision);
            } 
        }       
    	for (int j=i+1 ; j<Ega_Scene::getIt()->getNbEntity() ; j++)
    	{ 
    	    Ega_Entity *_entite2 = Ega_Scene::getIt()->getEntity(j);
    	    if ( _entite1->isPhysic() && _entite2->isPhysic())
    	    {
    	    	result = dCollide( _entite1->getCollisionId(), _entite2->getCollisionId(), POINT_CONTACT, _contactgeom, sizeof(dContactGeom) );
    	    	if (result)
    	    	{
                    for(int k=0;k<result;k++)
                    {
                        _collision._contact[k].pos[0]=_contactgeom[k].pos[0];
                         _collision._contact[k].pos[1]=_contactgeom[k].pos[1];
                          _collision._contact[k].pos[2]=_contactgeom[k].pos[2];
                        _collision._contact[k].normal[0]=_contactgeom[k].normal[0];
                         _collision._contact[k].normal[1]=_contactgeom[k].normal[1];
                          _collision._contact[k].normal[2]=_contactgeom[k].normal[2];
                        _collision._contact[k].depth = _contactgeom[k].depth;
                    }
                    _collision.Id1 = i; _collision.Id2 = j;
                    _collision.vit1 = _entite1->getSpeed(); _collision.vit2 = _entite2->getSpeed();
                    _collision.pos1 = _entite1->getPosition(); _collision.pos2 = _entite2->getPosition();
                    _collision.rot1 = _entite1->getAngularSpeed(); _collision.rot2 = _entite2->getAngularSpeed();
    	    		_collision.nbContact = result;
                    col_vectorCollision.push_back(_collision);
   	    		}
   		    }    	 		
    	}
   	}       
}    


collision Ega_Collide::getCollision(int _Id)
{	
   	return col_vectorCollision[_Id]; 
}    

int Ega_Collide::getNbCollision()
{
    return col_vectorCollision.size();
}    
	
void Ega_Collide::addGeomId(dGeomID _Id)
{
    col_vectorIdGeom.push_back(_Id);
}    
