/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */
 
 
#ifndef _EGA_GAME_H_
#define _EGA_GAME_H_

#include "engine/Ega_Scene.h"

#include "manager/Ega_GameEventsManager.h"
//#include <sdl.h>
#include <time.h>

/**
 * Class who manage all the game.
 * Vcb_Game test new event, process them, update entity, and draw them
 *
 * @author Matthieu Gautier
 * @author Pierre Leduc
 */
class Ega_Game
{
 public:
	static void create();
	static Ega_Game* getIt();
     	
    Ega_Game(); 	
    virtual ~Ega_Game(); 
      	
	void play();	
	void init();  
    bool updateEvents();      
           
 private:     
    static Ega_Game* gam_this;
    
	Ega_Window* gam_win;
	Ega_Scene*  gam_scene; 
	Ega_Player* gam_player;
	Ega_Camera* gam_camera;
	
	Ega_GameEventsManager* gam_events;	

    //Vect2 gam_posMouse,gam_milEcran;
	//bool gam_bPause,gam_bForce;
	
	float gam_zoom;
	float m_zoom,m_dzoom,m_dpower,m_droll,m_dpitch;
	double gam_lastTime, gam_dtime;

};

#endif
