/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */

#include "engine/Ega_Scene.h"
#include "Ega_Physic.h"

#include "other/Ega_debug.h"

Ega_Physic::Ega_Physic(Ega_Collide *_Collide)
{
    phy_pCollide = _Collide;
}    

Ega_Physic::~Ega_Physic()
{
}
   
    
void Ega_Physic::setNewParam(Ega_Entity *_entite,double _dtemps)
{
    if ( _entite->getMasse() != -1)
    {
        collision _collision;
        bool _bcollision = false;
       	float fra_temps = _dtemps/1000;
        
        
        
     /*   for(int i=0;i<phy_pCollide->getNbCollision();i++)
    	{
    	    
    	    _collision = phy_pCollide->getCollision(i);
    	    contact _contact;
    	    _contact.pos = _contact.normal = 0.0;
    	    _contact.depth = 0;
    	    for(int j=0;j<_collision.nbContact;j++)
    	    {
    	        _contact.pos += _collision._contact[j].pos;
    	        _contact.normal += _collision._contact[j].normal;
    	        _contact.depth += _collision._contact[j].depth;
    	    }
    	    _contact.pos /= _collision.nbContact;
            _contact.normal /= _collision.nbContact;
    	    _contact.depth /= _collision.nbContact;
    	    
         	Ega_Entity *_entite1,*_entite2;
    	    _entite1 = Ega_Scene::getIt()->getEntity(_collision.Id1);
            if (_collision.Id2 != -1)    
                 _entite2 = Ega_Scene::getIt()->getEntity(_collision.Id2);
                 
    	    if ( (_entite1==_entite) || (_entite2==_entite) )
    	    {
    	        Vect3 _normal = _contact.normal;
    	        Vect3 _vit1,_newVit1,_vit1N,_newVit1N,_vit1T;
    	        Vect3 _varPos;
    	        if (_collision.Id2 == -1)
    	        {
         	        _vit1 = _collision.vit1;
         	        _vit1N = projec(_vit1,_normal);  // vect vitesse de 1 sur lequel on travail
         	        _vit1T = _vit1 - _vit1N; // vect vitesse de 1 qu'on ne touche pas
         	        _newVit1N = -_vit1N;
         	        _varPos = _contact.depth * _normal;
    	        }
    	        else
    	        {
         	        Vect3 _vit2,_vit2N;
         	        
         	        float _Dmasse,_Smasse;
    	        
        	        if (_entite==_entite1)
        	        {
            	        _vit1 = _collision.vit1; //vitesse de 1
            	        _vit2 = _collision.vit2;
        	        }else
        	        {
            	        _entite2 = _entite1; // on inverse les entites
            	        _normal = -_normal;
   	            	
   	   	            	_vit1 = _collision.vit2; //vitesse de 1
   	   	            	_vit2 = _collision.vit1;
   	            	}
   	            	
   	            	_vit1N = projec(_vit1,_normal);  // vect vitesse de 1 sur lequel on travail
   	            	_vit1T = _vit1 - _vit1N; // vect vitesse de 1 qu'on ne touche pas
   	            	_vit2N = projec(_vit2,_normal);
           	    
  	            	// calcul de la nouvelle vitesse de 1 
  	            	if( _entite2->masse==-1)
  	            	{
   	  	            	_newVit1N = -_vit1N;
   	  	            	_varPos = _contact.depth * _normal;
  	            	}   	
  	            	else
  	            	{
      	            	_Dmasse=_entite->masse-_entite2->masse; _Smasse=_entite->masse+_entite2->masse;
      	            	_newVit1N = (2*_vit2N*_entite2->masse + _vit1N*_Dmasse)/_Smasse;
      	            	_varPos = _contact.depth * _normal /2;
  	            	}  		
            	}
            	_newVit1 = _newVit1N+_vit1T;
           		_entite->setSpeed(_newVit1);
           		_entite->changePosition(_varPos);
           		_bcollision = true;		
    	    } 
        }*/
Vect3 debug = _entite->getSpeed();
        if (!_bcollision)
        {
        	Vect3 v_temp;
        	quaternion q_temp;
            PRINT_PHYSIC1("physic perform:\n");
            PRINT_PHYSIC2("Avant vitesse[0]=%f\n",debug[0]);
            PRINT_PHYSIC2("      vitesse[1]=%f\n",debug[1]);
            PRINT_PHYSIC2("      vitesse[2]=%f\n",debug[2]);
        	_entite->setAcceleration( calculForce(_entite) );
        	v_temp = _entite->getAcceleration() * fra_temps;
        	_entite->changeSpeed( v_temp );
        	q_temp = calculMoment(_entite);
            _entite->setMoment( q_temp );
        	_entite->changeAngularSpeed( q_temp * fra_temps);
       	}   	
        _entite->changePosition( _entite->getSpeed() * fra_temps );
        _entite->changeOrientation( _entite->getAngularSpeed() * fra_temps );
        //quaternion _q;
        //_q = quaternion(_entite->speed-_dvit,_entite->speed);
        //_entite->changeAngularSpeed(_q);
debug = _entite->getSpeed();
            PRINT_PHYSIC2("Apres vitesse[0]=%f\n",debug[0]);
            PRINT_PHYSIC2("      vitesse[1]=%f\n",debug[1]);
            PRINT_PHYSIC2("      vitesse[2]=%f\n",debug[2]);      
            PRINT_PHYSIC1("end physic/n");  
    }
}    
    
int Ega_Physic::addForce(force _force)
{
    phy_vectorForce.push_back(_force);
    return phy_vectorForce.size() - 1;
}
    
void Ega_Physic::modForce(int Id, force _force)
{
    phy_vectorForce[Id] = _force;
}    

force Ega_Physic::getForce(int Id)
{
    return phy_vectorForce[Id];
}

int Ega_Physic::getNbForce()
{
    return phy_vectorForce.size();
}  

Vect3 Ega_Physic::calculForce(Ega_Entity *_entite)
{
    Vect3 _vforce,_distance;
    force _force;
    double _norme;
    
    _vforce=Vect3(0,0,0);
    for (int i=0;i<phy_vectorForce.size();i++)
    	{
    	    _force = phy_vectorForce[i];
         	_distance[0] = _force.pos[0];
         	_distance[1] = _force.pos[1];
         	_distance[2] = _force.pos[2];	
         	_norme = 1;
         	
          	if (_force.pos[3]=1)
          	{
          		_distance -= _entite->getPosition();
          		_norme = _distance.norme();
          		for (int j=1;j<_force.decroissement;j++)
          			_norme *= _norme;
  			}
    	    _vforce += (_distance*_force.intensite) / _norme;    	    
    	}

    float k = 0.5;
   	_vforce -= _entite->getSpeed() * k;

   	   //calcul des forces du aux forces de frottement
       	
   	Ega_SpaceShip * ship = dynamic_cast <Ega_SpaceShip *> (_entite );   	
   	if ( ship != NULL ) 
   	{

   	    //quaternion = 
        //Ega_SpaceShip *_ship;
        ship = (Ega_SpaceShip *)_entite;
        _vforce +=  rotate ( Vect3(0,0,1),ship->getOrientation() )*ship->getPowerReactor();
                 //- _ship->sps_powReact*(Vect3(0.0,-1.0,0.0)*_ship->getAngularSpeed().getAngle()*_ship->getOrientation());
    }
    
   	return _vforce;
}    

quaternion Ega_Physic::calculMoment(Ega_Entity *_entite)
{
    float k = 0.8;
    quaternion _moment;
    _moment =  ~(_entite->getAngularSpeed()*k); // le moment est oppos a la vitesse de rot
    return _moment;
}
