/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */


/* Description du fichier :
 *
 * description de la classe Fl_Physic
 * contient toute les rgles physiques, calcule les nouvelles coordonnes
 * en fonction des force et des collissions
 *
 */

#ifndef _EGA_PHYSIC_H_
#define _EGA_PHYSIC_H_

#include <ode.h>
#include <vector>
#include "tool/Ega_Tools.h"
#include "entity/Ega_Player.h"
#include "entity/Ega_Entity.h"
#include "Ega_Collide.h"

#include "entity/Ega_SpaceShip.h"


/**
 * manage entities, collisions, forces.
 * Contain physic rules for update entities position during the game
 *
 * @author	Gautier Matthieu
 * @see Ega_Collide
 */
class Ega_Physic
{
public:
	Ega_Physic(Ega_Collide *_collide);
	virtual ~Ega_Physic();
	void setNewParam(Ega_Entity*_entite,double _dtemps);
	int addForce(force _force);
	void modForce(int Id, force _force);
	force getForce(int Id);
	int getNbForce();
	
private:
    Vect3 calculForce(Ega_Entity *_entite);
    quaternion calculMoment(Ega_Entity *_entite);
    
    Ega_Collide *phy_pCollide;
    vector<force> phy_vectorForce;
};

#endif
