/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */

#include "engine/Ega_Scene.h"

#include "other/Ega_debug.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
Ega_Scene* Ega_Scene::sce_this = 0;

void Ega_Scene::create()
{
	if (!sce_this)
		sce_this = new Ega_Scene();
}

Ega_Scene::Ega_Scene()
{
    sce_collide = new Ega_Collide();
	sce_physic = new Ega_Physic(sce_collide);
 	//sce_this = this;
}

Ega_Scene::~Ega_Scene()
{
	sce_this = 0;
	delete sce_physic;
}

void Ega_Scene::newParam(double _dtime)
{
    for (int i=0; i<sce_entityManager.getNbElement();i++)
    	sce_physic->setNewParam(sce_entityManager.getElement(i),_dtime);
}    

void Ega_Scene::makeCycle(double _dtime)
{
    //sce_collide->testCollision();
    newParam(_dtime);
}    

void Ega_Scene::draw()
{  	
  	/*for(int i=0;i<sce_collide->getNbCollision();i++)
    	{
    	    collision _collision = sce_collide->getCollision(i);
    	    for(int j=0;j<_collision.nbContact;j++)
    	    {
    	        contact _contact = _collision._contact[j];
    	        glBegin(GL_LINES);
    	        glColor4f(1,1,0,0);
    	        glVertex3d(_contact.pos.x-10,_contact.pos.y,_contact.pos.z);
    	        glVertex3d(_contact.pos.x+10,_contact.pos.y,_contact.pos.z);
    	        glVertex3d(_contact.pos.x,_contact.pos.y-10,_contact.pos.z);
    	        glVertex3d(_contact.pos.x,_contact.pos.y+10,_contact.pos.z);
    	        glVertex3d(_contact.pos.x,_contact.pos.y,_contact.pos.z-10);
    	        glVertex3d(_contact.pos.x,_contact.pos.y,_contact.pos.z+10);
    	        glEnd();
    	    }
    	} */   
	 PRINT_DISPLAY1("before light\n");
  	 sce_lightManager.applyAllLights();
  	 //sce_player->draw();
  	 PRINT_DISPLAY1("before drawing\n");
  	 sce_entityManager.drawAll();
     PRINT_DISPLAY1("after drawing\n");		
}

void Ega_Scene::addCamera(Ega_Camera *camera)
{
    sce_cameraManager.addCamera(camera);
}

void Ega_Scene::addLight(Vcb_Light *light)
{
    sce_lightManager.addElement(light);
}

void Ega_Scene::applyMaterial(GLuint id)
{
    sce_materialManager.applyMaterial(id);
}  

void Ega_Scene::resetMaterial(GLuint id)
{
    sce_materialManager.resetMaterial(id);
} 

Vcb_Material *Ega_Scene::getMaterial(int id)
{
    return sce_materialManager.getElement(id);
} 

GLuint Ega_Scene::addMaterial(Vcb_Material *material)
{
	return sce_materialManager.addElement(material);
}

void Ega_Scene::addEntity(Ega_Entity *entity)
{
    sce_entityManager.addElement(entity);
}

void Ega_Scene::addGeomId(dGeomID _Id)
{
    sce_collide->addGeomId(_Id);
}

int Ega_Scene::addForce(force _force)
{
    return sce_physic->addForce(_force);
}  

void Ega_Scene::addPlayer(Ega_Player *player)
{
    sce_player = player;
}  
 
Ega_Player *Ega_Scene::getPlayer()
{
    return sce_player; 
}

Ega_Camera *Ega_Scene::getCamera()
{
    return sce_cameraManager.getCamera(0);
}    
 
Ega_Entity* Ega_Scene::getEntity(int _Id)
{
    return sce_entityManager.getElement(_Id);
}

int Ega_Scene::getNbEntity()
{
    return sce_entityManager.getNbElement();
}    

int Ega_Scene::getNbMaterial()
{
    return sce_materialManager.getNbElement();
} 

void Ega_Scene::setRadiusWorld(int _radiusWorld)
{
    /*vecteur4 _temp;
    Ega_Entity *_entite;*/
    
    sce_radiusWorld = _radiusWorld;
    /*
    _entite = new Ega_Entity(FIC_SPHERE_UNIV,GL_POLYGON);
	_entite->setPhysic(false);
	_entite->setmasse(-1);
	_entite->setinert(0);
	_temp = 0.0;
	_temp.w = _dist;
	_entite->setpos(_temp);
	_entite->setvit(0.0);
	_entite->enregistrer();*/
}	

