/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */


/* Description du fichier :
 *
 * description de la classe Fl_Monde
 * represente l'espace de jeu
 *  gerer les entits, teste les collisions, changent les coordonnes des entits.
 */

#ifndef _EGA_SCENE_H_
#define _EGA_SCENE_H_

#include "engine/Ega_Window.h"
#include "entity/Ega_Player.h"
#include "manager/Ega_EntityManager.h"
#include "manager/Ega_MaterialManager.h"
#include "manager/Ega_CameraManager.h"
#include "manager/Ega_LightManager.h"
#include "Ega_Collide.h"
#include "Ega_Physic.h"

/**
 * Ega_Scene represents the world of the game.
 * 
 *
 * @author Gautier Matthieu
 * @author Pierre Leduc
 */
class Ega_Scene 
{
public:
    Ega_Scene();
    virtual ~Ega_Scene();
    
	static void create();	
	static Ega_Scene* getIt(){ return sce_this; }


	//void addObjet(Ega_Objet* _objet);
	void addEntity(Ega_Entity *entity);
	GLuint addMaterial(Vcb_Material *material);
	void addCamera(Ega_Camera *camera);
	void addPlayer(Ega_Player *player);
	void addLight(Vcb_Light *light);
	void addGeomId(dGeomID _Id);
	
	int  addForce(force _force);
	void newParam(double _dtemps);	
	void makeCycle(double _dtemps);
	
	void draw(/*bool _bAffForce*/);
	
	int getNbEntity();
	int getNbMaterial();
	Ega_Entity* getEntity(int _Id);
    Vcb_Material *getMaterial(int id); 
    Ega_Camera *getCamera();
    Ega_Player *getPlayer();	 	
    void applyMaterial(GLuint id);
    void resetMaterial(GLuint id);
	
	int getRadiusWorld() { return sce_radiusWorld; };
	void setRadiusWorld(int _radiusWorld);

private:
    
    static Ega_Scene* sce_this;
	
	Ega_Player         *sce_player;
    Ega_EntityManager   sce_entityManager;
	Ega_MaterialManager sce_materialManager;
	Ega_CameraManager   sce_cameraManager;
	Ega_LightManager    sce_lightManager;
		
	Ega_Collide *sce_collide;
	Ega_Physic  *sce_physic;

	int sce_radiusWorld;

};

#endif
