/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */

#ifndef _EGA_WINDOW_H_
#define _EGA_WINDOW_H_


#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <sdl.h>
#include <gl/gl.h>
#include <gl/glu.h>

#include "other/Ega_Global_Params.h"
#include "menu/Ega_GuiLabel.h"
#include "display/Ega_Font.h"

/**
 * Class to manage the window with SDL.
 *
 * @author Gautier Matthieu
 * @author Pierre Leduc
 */
class Ega_Window  
{
public:
    Ega_Window(char * WinName, int Width, int Height, bool FullScreen, bool ShowMouse);
	virtual ~Ega_Window();
    
   	static Ega_Window* win_this;
	static Ega_Window* getIt() { return win_this; }	
    
	void initGL();
	void setFont(char * fontFileName);
	void setFont(Ega_Font *font);

	void end();
	void begin();
	
	void setPerspectiveMode();
	void setOrthoMode();
	
	int  getWidth()  { return win_width;  }
	int  getHeight() { return win_height;  }
	
	SDL_Surface *getSDLSurf();
	
	void createWindowContext();
	
	void setWindow(int Width, int Height);	
   	
private:
	SDL_Surface *win_gl;
	SDL_Surface *win_video;
	
	Ega_Font* win_font;
	Ega_GuiLabel* win_fps;
	
	const SDL_VideoInfo* win_info;
	int  win_width;
    int  win_height;
    bool win_fullscreen;    
    int  win_flags;

	int fpsMoy;
	int fpsCompte;
	float fps;
	double curTime,lastTime ;
};

#endif
