/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */

#include "other/Ega_Global_Params.h"

#include "engine/Ega_Window.h"
#include "other/Ega_Camera.h"
#include "loader/Ega_Loader.h"
#include "engine/Ega_Scene.h"
#include "engine/Ega_Game.h"
#include "entity/Ega_Player.h"

#include "display/Ega_Sprite.h"
#include "menu/Ega_GuiGameMenuManage.h"

#include "other/Ega_debug.h"

#include "tool/Ega_Matrice.h"

#include <gl/gl.h>
#include <gl/glu.h>


Ega_Camera *Cam;
Ega_Sprite *ExplodSprite;
Ega_Texture *TexPart, *TexGalax, *TexSky;


static void draw_screen( void )
{
    static float angle = 0.0f;
    GLUquadricObj *quadObj;
   
    glMatrixMode( GL_MODELVIEW );
    glLoadIdentity( );
    
   	gluLookAt(0.0, 0.0, 150.0, 0.0,0.0,0.0,0.0,1.0,0.0);
	//glEnable(GL_CULL_FACE);
   	//glCullFace(GL_FRONT_AND_BACK);
/*   	glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_COLOR);
   	glPushAttrib( GL_TEXTURE_BIT);
    glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);*/
   /*	TexSky->applyTexture();
    glPushMatrix();
    glRotatef (-angle, (GLfloat)0.0, (GLfloat)1.0, (GLfloat)0.0);
    //glColor3ub(255,255,255);
  //  glCullFace(
    glPushMatrix ();
        
        quadObj = gluNewQuadric ();
        gluQuadricDrawStyle (quadObj, GLU_SMOOTH);
        gluQuadricNormals (quadObj, GLU_SMOOTH);
        gluQuadricTexture(quadObj, GL_TRUE);
        gluSphere (quadObj, 10000.0, 50, 50);
        
        /*glBegin(GL_QUADS);
		glTexCoord2f(0,0);        
        glVertex3f(-4,-4,0.0);
	
     	glTexCoord2f(1,0);      
        glVertex3f(4,-4,0.0);
        
		glTexCoord2f(1,1);                            
        glVertex3f(4,4,0.0);
        
		glTexCoord2f(0,1);                         
        glVertex3f(-4.0,4.0,0.0);
        glEnd();
        
    glPopMatrix();	
//    glDisable(GL_CULL_FACE);
    TexSky->resetTexture();    */
     //glPopMatrix();
  //  glPopAttrib();
    
    //glEnable(GL_LIGHTING);
    //glEnable(GL_LIGHT0);
    
    glPushMatrix();
    //glTranslatef(0.0,0.0,40.0);
    glRotatef (-angle, (GLfloat)0.0, (GLfloat)1.0, (GLfloat)0.0);
    Ega_Scene::getIt()->draw();

    glPopMatrix();
    //glDisable(GL_LIGHTING);

	//fprintf(stderr, "loop display\n");
    //glTranslatef( 0.0, 0.0, 5.0 );
    //glRotatef( 120*cos(angle/500.0), 0.0, 1.0, 0.0 );
    //glRotatef( angle/5.0, 1.0, 0.0, 0.0 );

    angle+=0.5;

}

/*void draw_menu()
{
    static float x = 0;
    x+=1.0;
    glMatrixMode( GL_MODELVIEW );
    glLoadIdentity( );
    
    	glEnable(GL_TEXTURE_2D);
	//glEnable(GL_DEPTH_TEST);
	
	glPushAttrib(GL_TEXTURE_BIT);
	glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
	glColor4f(1.0, 1.0, 1.0, 1.0);
	glEnable(GL_BLEND);									// Enable Blending
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	
	TexPart->applyTexture();

	glPushMatrix();
    glTranslatef(0.0, 0.0, -1.0);
	glBegin(GL_QUADS);
	// face arriere
		glTexCoord2i(0,0);glVertex3i(20,10,0);
		glTexCoord2i(1,0);glVertex3i(780,10,0);
		glTexCoord2i(1,1);glVertex3i(780,590,0);
		glTexCoord2i(0,1);glVertex3i(20,590,0);
	glEnd();
	
	TexPart->resetTexture();
	
	TexGalax->applyTexture();
	
	glPushMatrix();
	glTranslatef(400.0, 520.0, 0.0);
	glScalef(1.6, 0.3, 1.0);
	glPushMatrix();
	    glRotatef(x, 0.0, 0.0, 1.0);
	    glBegin(GL_QUADS);
	    glTexCoord2i(0,0);glVertex3i(-128,-128,0);
		glTexCoord2i(1,0);glVertex3i(128,-128,0);
		glTexCoord2i(1,1);glVertex3i(128,128,0);
		glTexCoord2i(0,1);glVertex3i(-128,128,0);
		glEnd();
	glPopMatrix();
	glPopMatrix();
	
	TexGalax->resetTexture();
	
	glPopMatrix();
	glPopAttrib();
	glDisable(GL_BLEND);	
}*/

    
int main( int argc, char* argv[] )
{   
    
    Ega_Window *win = new Ega_Window("Fly'nSpace", (int) FENETRE_LARGEUR, (int) FENETRE_HAUTEUR, FULLSCREEN, true); 
    
    Ega_Loader::create();
	Ega_Scene::create();
	Ega_Scene::getIt()->setRadiusWorld(10000);	
    Ega_Game::create();
      
    
    //ExplodSprite = new Ega_Sprite( "Textures/explod.png", "Textures/explodm.jpg", Cam, 5, 5, 5.0);
    //ExplodSprite = new Ega_Sprite( "Textures/menuC.jpg", "Textures/menuA.jpg", Cam, 1, 1, 5.0);
    
    //TexSky = new Ega_Texture( "Textures/Space2.jpg" );
    //TexGalax = new Ega_Texture( "Textures/menuGalaxC.jpg", "Textures/menuGalaxA.jpg" );
    
    //TexPart = new Ega_Texture( "Textures/menuC.jpg", "Textures/menuA.jpg" );
    
   
    
PRINT_GAME1("before add player\n");
    Ega_Player *player = new Ega_Player(SHIP);
   // player->getShip()->setSystemReactor(PART_TEXT, PART_TEXTM);
    player->getShip()->setMasse(5);
    player->getShip()->store();
    Ega_Scene::getIt()->addPlayer(player);
    PRINT_GAME1("after add player\n");
    
    //Ega_Loader::getIt()->loadElements("ship.xml");
    Ega_Loader::getIt()->loadElements(SKY);
    Ega_Loader::getIt()->loadElements(SCENE_BASE);
    Ega_Loader::getIt()->loadElements(CIRCUIT);
    Ega_Loader::getIt()->loadElements(PLANET);
    
    
    
    

    //Ega_Loader::getIt()->loadElements("sphere.xml");
    //Ega_Loader::getIt()->loadElements("tore.xml");
	
	//Ega_Game::getIt()->play();
	
	Ega_GuiGameMenuManage *GGME = new Ega_GuiGameMenuManage();	
    while( GGME->manageGui() ) 
    {
        win->begin();        
        win->setPerspectiveMode();
        
        draw_screen( );
        
        win->setOrthoMode();        
        win->end();
    }
 
    delete GGME;
	delete Ega_Game::getIt(); 
    delete Ega_Scene::getIt(); 
    delete Ega_Loader::getIt(); 
    delete Ega_Window::getIt();
    SDL_Quit();
    return 0;
}

