/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */
 
 
#include "engine/Ega_Scene.h"
#include "entity/Ega_SpaceShip.h"

#include "other/Ega_debug.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Ega_SpaceShip::Ega_SpaceShip(char *fileName) : Ega_Entity(fileName)
{
	sps_powReact = 0;
	sps_systPart = NULL;
}   

Ega_SpaceShip::~Ega_SpaceShip()
{
    delete sps_systPart;
} 

void Ega_SpaceShip::setSystemReactor( char * texName, char * maskName )
{
   // sps_systPart = new Ega_SystemParticule(20,REACTEUR | MORPH);
	
	Vcb_Material *mat = new Vcb_Material();
    mat->setDiffTexture( texName, maskName );
  	//mat->store();
/*	sps_systPart->DefinirMaterial(mat);
	sps_systPart->DefinirAttraction(0.0,0.0,-0.8);
	sps_systPart->DefinirTaille(12.0);
	sps_systPart->DefinirDureeDeVie(10.0,0.0);
	//sys2->DefinirCouleurs(12,colors);
	sps_systPart->InitReacteur(0.0,0.0,-28.0,10.0);
	sps_systPart->OrienterReacteur(0.0,0.0,-1.0,0.2,0.2,0.2);
	sps_systPart->DefinirToleranceReacteur(0.2,0.2,0.2);
	//sys2->DefinirCouleursArc(12,colors,40.0);
	sps_systPart->InitMorph(200.0,true);*/
	//delete mat;
}

void Ega_SpaceShip::setPowerReactor(float _power)
{
    sps_powReact = _power;
    if (sps_powReact < 0 ) sps_powReact=0;
    if (sps_powReact > POWER_MAX) sps_powReact=POWER_MAX;
} 

void Ega_SpaceShip::changePowerReactor(float _dpower)
{
    sps_powReact += _dpower;
    if (sps_powReact <= 0 ) sps_powReact=0;
    if (sps_powReact >= POWER_MAX) sps_powReact=POWER_MAX;
} 

float Ega_SpaceShip::getPowerReactor()
{
    return sps_powReact;
} 


void Ega_SpaceShip::draw()
{
    putTransform();
    Objects->drawAll();
    
/*    if( sps_systPart ){
      sps_systPart->replaceReacteur(getPosition());
      Vect3 axis = getOrientation().getAxis();
      sps_systPart->ReOrienterReacteur(axis[0], axis[1], axis[2]);
      sps_systPart->DefinirAttraction(axis[2], axis[0], -axis[1]);
      PRINT_PARTICULE1("begin particule draw\n");
      sps_systPart->Afficher();
       }
    PRINT_PARTICULE1("end particule draw\n");  */
    glPopMatrix();
}

