/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */

#ifndef _EGA_SPACESHIP_H_
#define _EGA_SPACESHIP_H_

#include "entity/Ega_Entity.h"
#include "tool/Ega_Tools.h"
#include "display/Ega_SystemParticule.h"

#define POWER_MAX 1300
/**
 * Class for SpaceShip management.
 *
 * @author Gautier Matthieu
 * @author Leduc Pierre
 */
class Ega_SpaceShip : public Ega_Entity
{
//friend class Ega_Physic;

public:

	Ega_SpaceShip(char *fileName);
	virtual ~Ega_SpaceShip();
	
	virtual void draw();
	
	void setSystemReactor( char * texName, char * maskName );
	
	void setPowerReactor(float _power);
	void changePowerReactor(float _dpower);
	float getPowerReactor();

	
protected:
    float sps_powReact;
    
    Ega_SystemParticule *sps_systPart;
};

#endif
