/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */
 
 
#ifndef _EGA_OBJETPARSER_H_
#define _EGA_OBJETPARSER_H_

#include "tool/Ega_Tools.h"
#include "entity/Ega_Entity.h"
#include <gl/gl.h>
#include <string>
#include <vector>

using namespace std;

/**
 * Temp class used by the parser to load a objet.
 *
 * @author Gautier Matthieu
 * @author Leduc Pierre
 */
class Ega_ObjectParser
{
private:
	vector<Vect3>  obp_listVertex;
	vector<face>   obp_listFaces;
	vector<Vect3>  obp_listNormals;

	vector<face>   obp_listTexFaces;
	vector<Vect2>  obp_listTexCoords;
	
	

public:
	Ega_ObjectParser();
	virtual ~Ega_ObjectParser();

	GLuint createDisplayList( Ega_Object *object, Ega_Entity *entity);

  	void addFace(face _face);
	void addVertex(Vect3 _vertex);
	void addTexCoord(Vect2 _texcoord);
	void addTexFace(face _texface);
	void addNormal(Vect3 _normal);

	vector<face>     getFaces()      { return obp_listFaces; } ;
	vector<face>     getTexFaces()   { return obp_listTexFaces; } ;
	vector<Vect2>    getTexCoord()   { return obp_listTexCoords; };
	vector<Vect3>    getVertex()     { return obp_listVertex; } ;
	vector<Vect3>    getNormals()    { return obp_listNormals; } ;

	int get_nbVertex()    { return obp_listVertex.size(); };
	int get_nbTexFaces()  { return obp_listTexFaces.size(); };
	int get_nbTexCoords() { return obp_listTexCoords.size(); };
	int get_nbNormals()   { return obp_listNormals.size(); };
	int get_nbFaces()     { return obp_listFaces.size(); };

};

#endif
