/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */
 
#include "Ega_Parser.h"

#include "other/Ega_debug.h"
#include <iostream>

Ega_Parser::Ega_Parser(char *fileName)
{		
    fileName_      = fileName;   
    entity_        = NULL;
    object_        = NULL;
    material_      = NULL;
    light_         = NULL;
    camera_        = NULL; 
    objectManager_ = NULL;
}

Ega_Parser::~Ega_Parser()
{
}

int str2Int(char * attrib)
{
        int index ;
        stringstream str ( attrib);
        str >> index ;
        return index;
}

GLuint str2GLuint(char * attrib)
{
        GLuint index ;
        stringstream str ( attrib);
        str >> index ;
        return index;
}

double str2Double(char * attrib)
{
        double index ;
        stringstream str ( attrib);
        str >> index ;
        return index;
}

/*int Ega_Parser::getIndice()
{
    return str2Int((char *) xmlGetProp(par_xmlCursor, (const xmlChar*)INDICE));
}

char* Ega_Parser::getStringAttrib()
{
    return ( char *) xmlGetProp(par_xmlCursor, (const xmlChar*)STRING);
}

int Ega_Parser::getIntAttrib(char* type)
{
    return str2Int((char *) xmlGetProp(par_xmlCursor, (const xmlChar*)type));
}
*//*
GLuint Ega_Parser::getGLuintAttrib(char* type)
{
    return ( GLuint ) str2Int((char *) xmlGetProp(par_xmlCursor, (const xmlChar*)type));
}

double Ega_Parser::getDoubleAttrib(char* type)
{
    return str2Double(( char *) xmlGetProp(par_xmlCursor, (const xmlChar*)type));
}*/

/*bool Ega_Parser::isFlag(char * flag)
{
    return !xmlStrcmp(par_xmlCursor->name, (const xmlChar *)flag);
}

bool Ega_Parser::getGroupObject()
{
    par_xmlCursor = par_xmlCursor->xmlChildrenNode;
    do
    {
        if( par_xmlCursor->name == (const xmlChar*)"text" )
        {
            continue;
        }  
        else if( isFlag(GEOMOBJECT) )
        {
                //fprintf(stderr, "\n name: %s \n type: %d \n\n", (const char*) par_xmlCursor->name , par_xmlCursor->type);
                par_object = new Ega_Object();
                par_objParser = new Ega_ObjectParser();                 
                if(getObject())
                {
                      par_object->setDisplayList( par_objParser->createDisplayList(par_object, NULL) );
                      par_entity->addObject( par_object );  
                      PRINT_LOADER1("perfect load Object1\n");
                }    
                delete par_objParser; par_objParser = NULL;
                par_object = NULL;
        }   
        else if( getTransform() )
        {}
        //fprintf(stderr, "\n name: %s \n type: %d \n\n", (const char*) par_xmlCursor->name , par_xmlCursor->type);
        if(par_xmlCursor->next != NULL)
        {    par_xmlCursor = par_xmlCursor->next;}
        else break; 
    }
    while( par_xmlCursor != NULL );
    par_xmlCursor = par_xmlCursor->parent; 
    
    return true;
}*/
            
     
/*bool Ega_Parser::getObject()
{
    par_xmlCursor = par_xmlCursor->xmlChildrenNode;
    do
    {
        //fprintf(stderr, "\n name: %s \n type: %d \n\n", (const char*) par_xmlCursor->name , par_xmlCursor->type); 
        if( par_xmlCursor->name == (const xmlChar*)"text" )
        {
            continue;
        }         
        else if( isFlag(MATERIAL_REF ) )
        {
            par_object->setMaterialID(par_matId[par_matIdActiv]);
        }
        else if( isFlag(MESH_VERTEX ) )
        {
            par_objParser->addVertex(Vect3( getDoubleAttrib(ATT_X), getDoubleAttrib(ATT_Y), getDoubleAttrib(ATT_Z) ));
        } 
        else if( isFlag(MESH_FACE ) )
        {
            par_objParser->addFace(face( getIntAttrib(ATT_V1), getIntAttrib(ATT_V2), getIntAttrib(ATT_V3)));
        }   
        else if( isFlag(MESH_VERTEXNORMAL ) )
        {
            par_objParser->addNormal(Vect3( getDoubleAttrib(ATT_X), getDoubleAttrib(ATT_Y), getDoubleAttrib(ATT_Z)));
        }
        else if( isFlag(MESH_TVERT ) )
        {
            par_objParser->addTexCoord(Vect2( getDoubleAttrib(ATT_X), getDoubleAttrib(ATT_Y)));
        }
        else if( isFlag(MESH_TFACE ) )
        {
            par_objParser->addTexFace(face( getIntAttrib(ATT_V1), getIntAttrib(ATT_V2), getIntAttrib(ATT_V3)));
        }  
        else if( getTransform() )
        {}
        
        if(par_xmlCursor->next != NULL)
        {    par_xmlCursor = par_xmlCursor->next;}
        else break; 
    }
    while( par_xmlCursor != NULL );
    par_xmlCursor = par_xmlCursor->parent;  
    //fprintf(stderr, "perfect load Object");
    return true;         
}

*/
bool Ega_Parser::parseDocument(){
	TiXmlDocument xmlDocument_ = TiXmlDocument(fileName_);
	if( !xmlDocument_.LoadFile() ) {
        PRINT_LOADER1("Document not parsed successfully. \n");
        return false;
    }
	TiXmlElement *xmlDocumentRootElement = xmlDocument_.FirstChildElement();
	if (xmlDocumentRootElement == NULL) {
        PRINT_LOADER1("empty document\n");
        return false;
    }
	for(;xmlDocumentRootElement;xmlDocumentRootElement = xmlDocumentRootElement->NextSiblingElement()){
		if ( !strcmp(xmlDocumentRootElement->Value(),"egaModel") ){
			if ( !parseEgaModel(xmlDocumentRootElement,false)){
				return false;
			}
		}else{
			cerr << "Unknown value " << xmlDocumentRootElement->Value() << endl;
			return false;
		}
	}
    return true;
}

Ega_ObjectManager* Ega_Parser::parseDocumentObject(){
	objectManager_ = new Ega_ObjectManager();
	TiXmlDocument xmlDocument_ = TiXmlDocument(fileName_);
	if( !xmlDocument_.LoadFile() ) {
        PRINT_LOADER1("Document not parsed successfully. \n");
        return NULL;
    }
	TiXmlElement *xmlDocumentRootElement = xmlDocument_.FirstChildElement();
	if (xmlDocumentRootElement == NULL) {
        PRINT_LOADER1("empty document\n");
        return NULL;
    }
	for(;xmlDocumentRootElement;xmlDocumentRootElement = xmlDocumentRootElement->NextSiblingElement()){
		if ( !strcmp(xmlDocumentRootElement->Value(),"egaModel") ){
			if ( !parseEgaModel(xmlDocumentRootElement,true)){
				return NULL;
			}
		}else{
			cerr << "Unknown value " << xmlDocumentRootElement->Value() << endl;
			return NULL;
		}
	}
    return objectManager_;
}

bool Ega_Parser::parseEgaModel(TiXmlElement* mainElement,bool onlyGeom){
	TiXmlElement* currentElement = mainElement->FirstChildElement();
	for(;currentElement;currentElement = currentElement->NextSiblingElement()){
		if( !strcmp((char*)currentElement->Value() , "scLf") ){
				continue;
				// what is scLf ??? Nothing doing in the last code, so nothing is doing here.
			}else if ( !strcmp(currentElement->Value() , "scFs") ){
				continue;
				// what is scFs ??? Nothing doing in the last code, so nothing is doing here.
			}else if ( !strcmp(currentElement->Value() , "scTpf") ){
				continue;
				// what is scTpf ??? Nothing doing in the last code, so nothing is doing here.
			}
		if (!onlyGeom){
			if ( !strcmp(currentElement->Value() , "grp") ){
				if ( !parseGroup(currentElement))
					return false;
				continue;
			}else if ( !strcmp(currentElement->Value() , "liObj") ){
				if ( !parseLight(currentElement))
					return false;
				continue;
			}else if( !strcmp(currentElement->Value() , "caObj") ){
				if ( !parseCamera(currentElement))
					return false;
				continue;
			}
		}
		if ( !strcmp(currentElement->Value() , "maId") ){
			if ( !parseMaterial(currentElement))
				return false;
			continue;
		}else if ( !strcmp(currentElement->Value() , "obj") ){
			if ( !parseObject(currentElement, (onlyGeom?2:0)))
				return false;
			continue;
		}else{
			cerr << "Unknown value " << currentElement->Value() << endl;
			return false;
		}
	}
	return true;
}

bool Ega_Parser::parseMaterial(TiXmlElement* mainElement){
	double a,b,c;
	int i;
	char* difMapPath;
	char* opaMapPath;
	material_ = new Vcb_Material();
	
	TiXmlHandle mainHandle(mainElement);
	TiXmlElement* currentElement;

	currentElement = mainHandle.FirstChildElement("maDif").ToElement();;
	if(currentElement){
		currentElement->Attribute("a0",&a);	currentElement->Attribute("a1",&b);	currentElement->Attribute("a2",&c);
		material_->setDiffColor(Vect4(a, b, c, 1.0));
	}
	
	currentElement = mainHandle.FirstChildElement("maAmb").ToElement();
	if(currentElement){
		currentElement->Attribute("a0",&a);	currentElement->Attribute("a1",&b);	currentElement->Attribute("a2",&c);
		material_->setAmbientColor(Vect4(a, b, c, 1.0));
	}

	currentElement = mainHandle.FirstChildElement("maSpec").ToElement();
	if(currentElement){
		currentElement->Attribute("a0",&a);	currentElement->Attribute("a1",&b);	currentElement->Attribute("a2",&c);
		material_->setSpecColor(Vect4(a, b, c, 1.0));
	}

	currentElement = mainHandle.FirstChildElement("maShi").ToElement();
	if(currentElement){
		currentElement->Attribute("a0",&a);
		material_->setShininess(100.0 * a);
	}

	currentElement = mainHandle.FirstChildElement("maOpa").ToElement();
	if(currentElement){
		currentElement->Attribute("a0",&a);
		material_->setOpacity(1.0 - a);
	}

	currentElement = mainHandle.FirstChildElement("mapDif").FirstChildElement("bmp").ToElement();
	if(currentElement){
		difMapPath = (char*)currentElement->Attribute("a0");
		currentElement = mainHandle.FirstChildElement("mapOpac").FirstChildElement("bmp").ToElement();
		if(currentElement){
			opaMapPath = (char*)currentElement->Attribute("a0");
			material_->setDiffTexture(difMapPath, opaMapPath);
		}else
			material_->setDiffTexture(difMapPath);
	}

	mainElement->Attribute("i",&i);
	tempMapMaterialId_[i] =  material_->store();

	material_ = NULL;

	return true;
}
/**
 * Ega_parser::parseObject
 * Charge une geomtrie;
 * mainElement: noeud xml correspondant  la racine de la geometrie
 * objectMode: Faon de charger la geometrie : 0 nouvelle entity, 1 entity dj cre, 2 pas d'entity
 */
bool Ega_Parser::parseObject(TiXmlElement* mainElement, int objectMode){
	double a,b,c;
	int i;
	if(objectMode == 0)
		entity_ = new Ega_Entity();
    object_ = new Ega_Object();
    objParser_ = new Ega_ObjectParser();
	TiXmlElement* currentElement = mainElement->FirstChildElement();
	for(;currentElement;currentElement = currentElement->NextSiblingElement()){
		if( !strcmp(currentElement->Value() , "maRef") ){
			currentElement->Attribute("i",&i);
			object_->setMaterialID(tempMapMaterialId_[i]);
		}else if ( !strcmp(currentElement->Value() , "mhVer") ){
			currentElement->Attribute("a0",&a);
			currentElement->Attribute("a1",&b);
			currentElement->Attribute("a2",&c);
			objParser_->addVertex(Vect3( a, b, c ));
		}else if ( !strcmp(currentElement->Value() , "mhFac") ){
			currentElement->Attribute("a0",&a);
			currentElement->Attribute("a1",&b);
			currentElement->Attribute("a2",&c);
			objParser_->addFace(face( a, b, c ));
		}else if ( !strcmp(currentElement->Value() , "mhNorV") ){
			currentElement->Attribute("a0",&a);
			currentElement->Attribute("a1",&b);
			currentElement->Attribute("a2",&c);
			objParser_->addNormal(Vect3( a, b, c ));
		}else if ( !strcmp(currentElement->Value() , "mhTVer") ){
			currentElement->Attribute("a0",&a);
			currentElement->Attribute("a1",&b);
			objParser_->addTexCoord(Vect2( a, b));
		}else if ( !strcmp(currentElement->Value() , "mhTFac") ){
			currentElement->Attribute("a0",&a);
			currentElement->Attribute("a1",&b);
			currentElement->Attribute("a2",&c);
			objParser_->addTexFace(face( a, b, c ));
		}else if( !strcmp(currentElement->Value() , "pos") ){
			currentElement->Attribute("a0",&a);
			currentElement->Attribute("a1",&b);
			currentElement->Attribute("a2",&c);
			if(objectMode != 0)
				object_->setPosition(Vect3( a, b, c));
			else
				entity_->setPosition(Vect3( a, b, c));
		}else if( !strcmp(currentElement->Value() , "rotax") ){
			currentElement->Attribute("a0",&a);
			currentElement->Attribute("a1",&b);
			currentElement->Attribute("a2",&c);
			object_->setOrientAxis(Vect3( a, b, c));
		}else if( !strcmp(currentElement->Value() , "rotang") ){
			currentElement->Attribute("a0",&a);
			object_->setOrientAngle(a);	
		}else if( !strcmp(currentElement->Value() , "scal") ){
			currentElement->Attribute("a0",&a);
			currentElement->Attribute("a1",&b);
			currentElement->Attribute("a2",&c);
			object_->setScale(Vect3( a, b, c));
		}else{
			cerr << "Unknown value " << currentElement->Value() << endl;
			return false;
		}
	}
	
	if(objectMode == 0){
		object_->setDisplayList( objParser_->createDisplayList(object_, entity_) );
		entity_->addObject( object_ );
		entity_->store();
		entity_ = NULL;
	}else if(objectMode ==1){
		object_->setDisplayList( objParser_->createDisplayList(object_, entity_) );
		entity_->addObject( object_ );
	}else{
		object_->setDisplayList( objParser_->createDisplayList(object_, NULL) );
		objectManager_->addElement(object_);
	}
    PRINT_LOADER1("perfect load Object2\n"); 
	return true;
}
bool Ega_Parser::parseGroup(TiXmlElement* mainElement){
	double a,b,c;
	entity_ = new Ega_Entity();
	TiXmlElement* currentElement = mainElement->FirstChildElement();
	for(;currentElement;currentElement = currentElement->NextSiblingElement()){
		if ( !strcmp(currentElement->Value() , "obj") ){
			if ( !parseObject(currentElement,1))
				return false;
		}else if( !strcmp(currentElement->Value() , "pos") ){
			currentElement->Attribute("a0",&a);
			currentElement->Attribute("a1",&b);
			currentElement->Attribute("a2",&c);
			entity_->setPosition(Vect3( a, b, c));
		}else if( !strcmp(currentElement->Value() , "rotax") ){
			currentElement->Attribute("a0",&a);
			currentElement->Attribute("a1",&b);
			currentElement->Attribute("a2",&c);
			entity_->setOrientAxis(Vect3( a, b, c));
		}else if( !strcmp(currentElement->Value() , "rotang") ){
			currentElement->Attribute("a0",&a);
			entity_->setOrientAngle(a);
		}else if( !strcmp(currentElement->Value() , "scal") ){
			currentElement->Attribute("a0",&a);
			currentElement->Attribute("a1",&b);
			currentElement->Attribute("a2",&c);
			entity_->setScale(Vect3( a, b, c));
		}else{
			cerr << "Unknown value " << currentElement->Value() << endl;
			return false;
		}
	}
	entity_->store();
	entity_ = NULL;
	return true;
}
bool Ega_Parser::parseLight(TiXmlElement* mainElement){
	double a,b,c;
	light_ = new Vcb_Light();
	TiXmlHandle mainHandle(mainElement);
	TiXmlElement* currentElement;

	currentElement = mainHandle.FirstChildElement("liCol").ToElement();
	if(currentElement){
		currentElement->Attribute("a0",&a);	currentElement->Attribute("a1",&b);	currentElement->Attribute("a2",&c);
		light_->setDiffColor(Vect4(a, b, c, 1.0));
	}

	currentElement = mainHandle.FirstChildElement("pos").ToElement();
	if(currentElement){
		currentElement->Attribute("a0",&a);	currentElement->Attribute("a1",&b);	currentElement->Attribute("a2",&c);
		light_->setPos(Vect4(a, b, c, 1.0));
	}

	light_->store();
	light_ = NULL;
	return true;
}
bool Ega_Parser::parseCamera(TiXmlElement* mainElement){
	double a,b,c;
	camera_ = new Ega_Camera();
	TiXmlHandle mainHandle(mainElement);
	TiXmlElement* currentElement;

	currentElement = mainHandle.FirstChildElement("caNear").ToElement();
	if(currentElement){
		currentElement->Attribute("a0",&a);
		camera_->setNearPlan(a);
	}

	currentElement = mainHandle.FirstChildElement("caFovy").ToElement();
	if(currentElement){
		currentElement->Attribute("a0",&a);
		camera_->setFovy(a);
	}

	currentElement = mainHandle.FirstChildElement("caFovy").ToElement();
	if(currentElement){
		currentElement->Attribute("a0",&a);	currentElement->Attribute("a1",&b);	currentElement->Attribute("a2",&c);
		camera_->setPos(Vect3(a, b, c));
	}

	camera_->store();
	camera_ = NULL;
	return true;
}
/*
bool Ega_Parser::getTransform()
{     
     if( isFlag( TM_POS ) )
     {
         if(par_entity && !par_object) 
         {    par_entity->setPosition(Vect3( getDoubleAttrib(ATT_X), getDoubleAttrib(ATT_Y), getDoubleAttrib(ATT_Z)));   }
         else if( par_entity && par_object)            
         {    Vect3 pos = par_entity->getPosition(); 
              par_object->setPosition(Vect3( getDoubleAttrib(ATT_X)-pos[0], getDoubleAttrib(ATT_Y)-pos[1], getDoubleAttrib(ATT_Z)-pos[2]));   }
         else if( !par_entity && par_object )
         {    par_object->setPosition(Vect3( getDoubleAttrib(ATT_X), getDoubleAttrib(ATT_Y), getDoubleAttrib(ATT_Z)));   }
         return true;
     }
     else if( isFlag( TM_ROTAXIS ) )
     {
         if(par_entity && !par_object) 
         {    par_entity->setOrientAxis(Vect3( getDoubleAttrib(ATT_X), getDoubleAttrib(ATT_Y), getDoubleAttrib(ATT_Z)));   }
         else if((par_entity && par_object) || (!par_entity && par_object))
         {    par_object->setOrientAxis(Vect3( getDoubleAttrib(ATT_X), getDoubleAttrib(ATT_Y), getDoubleAttrib(ATT_Z)));   }
         return true;
     } 
     else if( isFlag( TM_ROTANGLE ) )
     {
         if(par_entity && !par_object)
         {    par_entity->setOrientAngle(float( getDoubleAttrib(ATT)));   }
         else if((par_entity && par_object) ||(par_entity && par_object))
         {    par_object->setOrientAngle(float( getDoubleAttrib(ATT)));   }
         return true;
     }   
     else if( isFlag( TM_SCALE ) )
     {
         if(par_entity && !par_object)
         {    par_entity->setScale(Vect3( getDoubleAttrib(ATT_X), getDoubleAttrib(ATT_Y), getDoubleAttrib(ATT_Z)));   }
         else if((par_entity && par_object) || (!par_entity && par_object))
         {    par_object->setScale(Vect3( getDoubleAttrib(ATT_X), getDoubleAttrib(ATT_Y), getDoubleAttrib(ATT_Z)));   }
         return true;
     }
     /*if( !strcmp( nodeName, CONTROL_POS_TRACK ) )
     {
            par_object->activPosAnim();
     }
     if( !strcmp( nodeName, CONTROL_POS_SAMPLE ) )
     {
            par_animation->addTexFace(face( convert2Int(atts[2]), convert2Double(atts[3]), convert2Double(atts[4]) ));
     }           
     if( !strcmp( nodeName, CONTROL_ROT_TRACK ) )
     {
            par_object->activRotAnim();
     }
     if( !strcmp( nodeName, CONTROL_ROT_SAMPLE ) )
     {
            par_object->activPosAnim();
     }
     if( !strcmp( nodeName, CONTROL_SCALE_TRACK ) )
     {
            par_object->activScalAnim();
     }
     if( !strcmp( nodeName, CONTROL_SCALE_SAMPLE ) )
     {
            par_object->activPosAnim();
     } 
     return false;*/
/*}

*/
/*
char* Ega_Parser::getMaterialMap()
{
    char* mapPath = NULL;
    par_xmlCursor = par_xmlCursor->xmlChildrenNode;
    do
    {
        if( par_xmlCursor->name == (const xmlChar*)"text" )
        {
            continue;
        }
        if( isFlag(BITMAP) )
        {
            mapPath = getStringAttrib();
        }
        if(par_xmlCursor->next != NULL)
        {    par_xmlCursor = par_xmlCursor->next;}
        else break; 
    }
    while( par_xmlCursor != NULL );
    par_xmlCursor = par_xmlCursor->parent;
    
    return mapPath;
}*/
  /*      
bool Ega_Parser::getMaterial()
{
    par_xmlCursor = par_xmlCursor->xmlChildrenNode;
    do
    {
        if( par_xmlCursor->name == (const xmlChar*)"text" )
        {
            continue;
        }
        if( isFlag(MATERIAL_DIFFUSE) )
        {
            par_material->setDiffColor(Vect4(getDoubleAttrib(ATT_R), getDoubleAttrib(ATT_G), getDoubleAttrib(ATT_B), 1.0));
        }
        else if( isFlag(MATERIAL_AMBIENT) )
        {
            par_material->setAmbientColor(Vect4(getDoubleAttrib(ATT_R), getDoubleAttrib(ATT_G), getDoubleAttrib(ATT_B), 1.0));
        }   
        else if( isFlag(MATERIAL_SPECULAR) )
        {
            par_material->setSpecColor(Vect4(getDoubleAttrib(ATT_R), getDoubleAttrib(ATT_G), getDoubleAttrib(ATT_B), 1.0));
        } 
        else if( isFlag(MATERIAL_SHINESTRENGTH) )
        {
            par_material->setShininess( 100.0*getDoubleAttrib(ATT) );
        } 
        else if( isFlag(MATERIAL_TRANSPARENCY ))
        {
            par_material->setOpacity( 1.0-getDoubleAttrib(ATT) );
        }
        else if( isFlag(MAP_DIFFUSE) )
        {
            strcpy_s(par_matDiffTexPath,getMaterialMap());
        }
        else if( isFlag(MAP_OPACITY) )
        {
            strcpy_s(par_matOpacTexPath,getMaterialMap());
        }    
        
        if(par_xmlCursor->next != NULL)
        {    par_xmlCursor = par_xmlCursor->next;}
        else break;        
            
    }
    while(par_xmlCursor != NULL);
    par_xmlCursor = par_xmlCursor->parent;
    
    return true;
}            
   */

/*
bool Ega_Parser::getLight()
{
    par_xmlCursor = par_xmlCursor->xmlChildrenNode;
    do
    {
        //fprintf(stderr, "\n name: %s \n type: %d \n\n", (const char*) par_xmlCursor->name , par_xmlCursor->type);
        
        if( par_xmlCursor->name == (const xmlChar*)"text" )
        {
            continue;
        }         
        else if( isFlag(LIGHT_COLOR ) )
        {
            par_light->setDiffColor(Vect4(getDoubleAttrib(ATT_R), getDoubleAttrib(ATT_G), getDoubleAttrib(ATT_B), 1.0));
        }
        else if( isFlag(TM_POS) )
        {
            par_light->setPos(Vect4(getDoubleAttrib(ATT_X), getDoubleAttrib(ATT_Y), getDoubleAttrib(ATT_Z), 1.0));
        }
        
        if(par_xmlCursor->next != NULL)
        {    par_xmlCursor = par_xmlCursor->next;}
        else break; 
    }
    while( par_xmlCursor != NULL );
    par_xmlCursor = par_xmlCursor->parent;  
    
    return true;         
}*/

/*
bool Ega_Parser::getCamera()
{
    par_xmlCursor = par_xmlCursor->xmlChildrenNode;
    do
    {
        //fprintf(stderr, "\n name: %s \n type: %d \n\n", (const char*) par_xmlCursor->name , par_xmlCursor->type);
        if( par_xmlCursor->name == (const xmlChar*)"text" )
        {
            continue;
        }         
        else if( isFlag(CAMERA_NEAR ) )
        {
            par_camera->setNearPlan(getDoubleAttrib(ATT));
        }
        //else if( isFlag(CAMERA_FAR) )
        //{
        //    par_camera->setFarPlan(getDoubleAttrib(ATT));
        //}
        else if( isFlag(CAMERA_FOVY) )
        {
            par_camera->setFovy(getDoubleAttrib(ATT));
        }
        else if( isFlag(TM_POS) )
        {
            par_camera->setPos(Vect3(getDoubleAttrib(ATT_X), getDoubleAttrib(ATT_Y), getDoubleAttrib(ATT_Z)));
        }
        //else if( isFlag( TM_ROTAXIS ) )
        //{
        //    par_entity->setOrient(Vect3( getDoubleAttrib(ATT_X), getDoubleAttrib(ATT_Y), getDoubleAttrib(ATT_Z)));   
        //} 
        
        if(par_xmlCursor->next != NULL)
        {    par_xmlCursor = par_xmlCursor->next;}
        else break; 
    }
    while( par_xmlCursor != NULL );
    par_xmlCursor = par_xmlCursor->parent;  
    
    return true;         
}*/
 
/*
bool Ega_Parser::getSceneElements() 
{
    par_xmlCursor = par_xmlCursor->xmlChildrenNode;
    while (par_xmlCursor != NULL)
    {
        //fprintf(stderr, "V1 \n name: %s \n type: %d \n\n", (const char*) par_xmlCursor->name , par_xmlCursor->type);
        if( par_xmlCursor->name == (const xmlChar*)"text" )
        {
            continue;
        }
        if (isFlag(MATERIAL_ID)) 
        {
                par_matDiffTexPath[0] = '\0';
                par_matOpacTexPath[0] = '\0';
                //free(par_matBumpTexPath);                
                par_material = new Vcb_Material();
                par_matIdActiv = Ega_Scene::getIt()->getNbMaterial();
                if(getMaterial())
                {
                    par_material->setDiffTexture( par_matDiffTexPath, par_matOpacTexPath );
//                    par_material->setBumpTexture( par_matBumpTexPath );
                    //par_matId = new GLuint;
                    par_matId[par_matIdActiv] = par_material->store(); ; 
                    PRINT_LOADER1("perfect load Material\n");
                }    
                par_material = NULL;                
        }
        else if(isFlag(GROUP))
        {
                par_entity = new Ega_Entity();                
                if(getGroupObject())
                {
                    par_entity->store();
                }
                par_entity = NULL;     
        } 
        else if(isFlag(GEOMOBJECT))
        {
                par_entity = new Ega_Entity();   
                par_object = new Ega_Object();
                par_objParser = new Ega_ObjectParser();                 
                if(getObject())
                {
                      par_object->setDisplayList( par_objParser->createDisplayList(par_object, par_entity) );                    
                      par_entity->addObject( par_object );
                      par_entity->store();  
                      PRINT_LOADER1("perfect load Object2\n");
                }    
                par_entity = NULL; 
                par_object = NULL;      
                delete par_objParser; par_objParser = NULL;
                
                      
        }   
        else if( isFlag(SHAPEOBJECT ) )
        {
             
        }
        else if( isFlag(LIGHTOBJECT ) )
        { 
                par_light = new Vcb_Light();
                if(getLight())
                {
                    par_light->store();
                    PRINT_LOADER1("perfect load Light\n");
                }                
                par_light = NULL;
        }
        else if( isFlag(CAMERAOBJECT ) )
        {         
                par_camera = new Ega_Camera();                
                if(getCamera())
                {
                    par_camera->store();
                    PRINT_LOADER1("perfect load Camera\n");
                } 
                par_camera = NULL;
        }     
        par_xmlCursor = par_xmlCursor->next;
    }
    return true;
}

*/
/*
bool Ega_Parser::getObjectElements()
{
    par_xmlCursor = par_xmlCursor->xmlChildrenNode;
    while (par_xmlCursor != NULL)
    {
        //fprintf(stderr, "V2 \n name: %s \n type: %d \n\n", (const char*) par_xmlCursor->name , par_xmlCursor->type);
        if( par_xmlCursor->name == (const xmlChar*)"text" )
        {
            continue;
        }
        if (isFlag(MATERIAL_ID)) 
        {
                par_matDiffTexPath[0] = '\0';
                par_matOpacTexPath[0] = '\0';
                //free(par_matBumpTexPath);                
                par_material = new Vcb_Material();
                par_matIdActiv = Ega_Scene::getIt()->getNbMaterial();
                if(getMaterial())
                {
                    par_material->setDiffTexture( par_matDiffTexPath, par_matOpacTexPath );
//                    par_material->setBumpTexture( par_matBumpTexPath );
                    //par_matId = new GLuint;
                    par_matId[par_matIdActiv] = par_material->store(); ; 
                }    
                par_material = NULL;                
        }
        else if(isFlag(GEOMOBJECT))
        {        
                par_object = new Ega_Object();
                par_objParser = new Ega_ObjectParser();                 
                if(getObject())
                {
                      par_object->setDisplayList( par_objParser->createDisplayList(par_object, NULL) );                      
                      par_objectManager->addElement( par_object );
                      PRINT_LOADER1("perfect load Object3");
                }    
                par_object = NULL;      
                delete par_objParser; par_objParser = NULL;                     
        }   
        par_xmlCursor = par_xmlCursor->next;
    }
    return true;
}   
*/
/*bool Ega_Parser::initParse() 
{
    par_xmlDoc = xmlParseFile(par_fileName);
    if (par_xmlDoc == NULL ) 
    {
        PRINT_LOADER1("Document not parsed successfully. \n");
        return false;
    }
    par_xmlCursor = xmlDocGetRootElement(par_xmlDoc);
    if (par_xmlCursor == NULL) 
    {
        PRINT_LOADER1("empty document\n");
        xmlFreeDoc(par_xmlDoc);
        return false;
    }
    if (xmlStrcmp(par_xmlCursor->name, (const xmlChar *) "egaModel")) 
    {
        PRINT_LOADER1("document of the wrong type, root node != egaModel");
        xmlFreeDoc(par_xmlDoc);
        return false;
    }
    return true;
}*/

/*
bool Ega_Parser::ParseElements() 
{
    if( !Parse() )
        return false;

    if(getSceneElements())
    {
        xmlFreeDoc(par_xmlDoc);
        return true;        
    }
    else
    {    
        return false;
    }    
}*/
/*
Ega_ObjectManager* Ega_Parser::ParseObjects()
{
    par_objectManager = NULL;
    if( !Parse() )
        return NULL;
        
    par_objectManager = new Ega_ObjectManager();
    if(getObjectElements())
    { 
        xmlFreeDoc(par_xmlDoc);
        return par_objectManager;
    }
    else
    {
        xmlFreeDoc(par_xmlDoc);
        return NULL;
    }    
}

*/