/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */

#include "engine/Ega_Scene.h"                                                                                                                                                                                                                                                                                                                                                                                                
#include "manager/Ega_GameEventsManager.h"


Ega_GameEventsManager::Ega_GameEventsManager()
{
    gem_listEvent.clear();
}

Ega_GameEventsManager::~Ega_GameEventsManager()
{
    while( gem_listEvent.size() )
    	gem_listEvent.pop_back();   
}    
 
bool Ega_GameEventsManager::pollKeyDown( SDL_keysym* keysym )
{   
    switch( keysym->sym ) 
    {
    case SDLK_ESCAPE: gem_listEvent.push_back(EVENT_EXIT);
        return true;
        break;
    case SDLK_LEFT:  //if(pitchKey == ONE_KEY 
                     gem_listEvent.push_back(EVENT_ROLL_PLUS);                   
        return true;
        break;    
    case  SDLK_RIGHT: //gem_listEvent.push_back(EVENT_END_ROLL); 
                       gem_listEvent.push_back(EVENT_ROLL_MINUS);                 
        return true;
        break;    
    case SDLK_DOWN:  //gem_listEvent.push_back(EVENT_END_PITCH);    
                     gem_listEvent.push_back(EVENT_PITCH_MINUS);                  
        return true;
        break;    
    case SDLK_UP:   //gem_listEvent.push_back(EVENT_END_PITCH);    
                    gem_listEvent.push_back(EVENT_PITCH_PLUS);                  
        return true;
        break;
    case SDLK_SPACE: gem_listEvent.push_back(EVENT_MOTOR);           
        return true;
        break;
    case SDLK_KP_PLUS: gem_listEvent.push_back(EVENT_ZOOM_PLUS);                  
        return true;
        break;
    case SDLK_KP_MINUS: gem_listEvent.push_back(EVENT_ZOOM_MINUS);                 
        return true;
        break;
    default:
        break;
    }    
    return true;
}


bool Ega_GameEventsManager::pollKeyUp( SDL_keysym* keysym )
{
    switch( keysym->sym ) 
    {
    case SDLK_ESCAPE: gem_listEvent.push_back(EVENT_EXIT);
        return true;
        break;
    case SDLK_LEFT: gem_listEvent.push_back(EVENT_END_ROLL);                  
        return true;
        break;    
    case SDLK_RIGHT: gem_listEvent.push_back(EVENT_END_ROLL);                   
        return true;
        break;    
    case SDLK_DOWN: gem_listEvent.push_back(EVENT_END_PITCH);                  
        return true;
        break;    
    case SDLK_UP: gem_listEvent.push_back(EVENT_END_PITCH);               
        return true;
        break;
    case SDLK_SPACE: gem_listEvent.push_back(EVENT_END_MOTOR);                   
        return true;
        break;
    case SDLK_KP_PLUS: gem_listEvent.push_back(EVENT_END_ZOOM);                  
        return true;
        break;
    case SDLK_KP_MINUS: gem_listEvent.push_back(EVENT_END_ZOOM);                 
        return true;
        break;
    default:
        break;
    }    
    return true;
}

bool Ega_GameEventsManager::pollMouseBoutDown( SDL_MouseButtonEvent* MouseBout )
{   
    event_mouse.Clk_x = event_mouse.Pos_x = MouseBout->x;
    event_mouse.Clk_y = event_mouse.Pos_y = MouseBout->y;
    
    switch( MouseBout->button ) 
    {
    case SDL_BUTTON_LEFT:
        return true;
        break;
    case SDL_BUTTON_MIDDLE:
        return true;
        break;
    case SDL_BUTTON_RIGHT:
        return true;
        break;
    default:
        return true;
        break;
    }
    return true;
}

bool Ega_GameEventsManager::pollMouseMotion( SDL_MouseMotionEvent* MouseMov )
{
    event_mouse.Clk_x = event_mouse.Pos_x = MouseMov->x;
    event_mouse.Clk_y = event_mouse.Pos_y = MouseMov->y;
    event_mouse.Mov_x = MouseMov->xrel;
    event_mouse.Mov_y = MouseMov->yrel;  
    
    return true;
}

bool Ega_GameEventsManager::pollAllEvents()
{
    bool result = true;
    
    while( gem_listEvent.size() )
    	gem_listEvent.pop_back();     
    	
    SDL_PumpEvents();
    while( SDL_PollEvent( &event_actual ) ) 
    {
        switch( event_actual.type ) 
        {
        case SDL_KEYDOWN: result =  pollKeyDown( &event_actual.key.keysym );
            break;
        case SDL_KEYUP: result =  pollKeyUp( &event_actual.key.keysym );
            break;
        case SDL_MOUSEBUTTONDOWN: result = pollMouseBoutDown( &event_actual.button );
            break;
        case SDL_MOUSEMOTION: result = pollMouseMotion( &event_actual.motion );
            break;
        case SDL_QUIT: gem_listEvent.push_back(EVENT_EXIT);
            return false;
            break;
        default: 
            result = true;
            break;
        }
    }
    return result;
}

EVENT_TYPE Ega_GameEventsManager::getEvent(int _number)
{
    return gem_listEvent[_number];
}

int Ega_GameEventsManager::getNbEvents()
{
    return gem_listEvent.size();
}

 

