/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */

#ifndef _EGA_GAMEEVENTSMANAGER_H_
#define _EGA_GAMEEVENTSMANAGER_H_

#include "input/Ega_Event.h"      
#include <vector>

#define ONE_KEY 0
#define TWO_KEY 1

enum EVENT_TYPE { EVENT_EXIT,
                  EVENT_MOTOR,EVENT_END_MOTOR,
                  EVENT_ZOOM_PLUS,EVENT_ZOOM_MINUS,EVENT_END_ZOOM,
                  EVENT_PITCH_PLUS,EVENT_PITCH_MINUS,EVENT_END_PITCH,
                  EVENT_ROLL_PLUS,EVENT_ROLL_MINUS,EVENT_END_ROLL};


/**
 * Manage the evnts during the game.
 *
 * @author Gautier Matthieu
 * @author Leduc Pierre
 */
class Ega_GameEventsManager: public Ega_Event
{
public:
    Ega_GameEventsManager();
    virtual ~Ega_GameEventsManager();
            
    virtual bool pollAllEvents();
    virtual bool pollKeyDown( SDL_keysym* keysym );
    virtual bool pollKeyUp( SDL_keysym* keysym );
    //virtual bool pollMouseBoutUp(SDL_MouseButtonEvent* MouseBout);
    virtual bool pollMouseBoutDown(SDL_MouseButtonEvent* MouseBout);  
    virtual bool pollMouseMotion( SDL_MouseMotionEvent* MouseMov ); 

    void checkInput();
  
    EVENT_TYPE getEvent(int _number);
    int getNbEvents();
  
private:     
    int pitchKey, rollKey;   
    vector<EVENT_TYPE> gem_listEvent;  
};
    
#endif

