/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */

#ifndef _VCB_BASIC_MANAGER_H_
#define _VCB_BASIC_MANAGER_H_

#include <vector>

template<class T,int init_size=16>
class Vcb_BasicManager
{
	public:
		
		Vcb_BasicManager();
		~Vcb_BasicManager();

		virtual int addElement(T* _elem);
		T* getElement(int _index);
		bool suppElement(int _index);
		
		int getNbElement();
	
		bool clear();
		
		int getFreeSpace();

		T* init_parser();
		T* get_next();

	protected:
		
		T* *m_list;

	private:
		
		std::vector<int> m_freeSpace;
		int max_index; // index max des element +1  ( ou index d'un futur element si c "pas de trou" ds la liste )
		int size;
		int nbElement;
		
		int currentElement; // for init_parser and get_next

		bool reallocTab(int _newsize);
				

};

#include "Vcb_Manager.imp"

#endif // _VCB_BASIC_MANAGER_H_
