/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */

#ifndef _EGA_GUIBUTTON_H_
#define _EGA_GUIBUTTON_H_

#include "Ega_GuiBase.h"
#include "display/Ega_Texture.h"
//#include "FL_Font.h"
//#include <string.h>
//#include <stdarg.h>

class Ega_GuiButton: public Ega_GuiBase
{
public:
    Ega_Texture *gui_tex;
    
    Ega_GuiButton(int _id, int _x, int _y, char* image):Ega_GuiBase(_id, _x, _y)
    {
        gui_tex = new Ega_Texture( image );        
    }
        
    virtual ~Ega_GuiButton()
    {
        delete gui_tex;
    }    
    
    void draw(int isSelectedId)
    {
        gui_tex->applyTexture();
        glPushMatrix();
                if( ID == isSelectedId )
                        glScalef(1.2, 1.2, 0.0);                
        
                glTranslatef(float(x), float(y), 0.0);                
                glBegin(GL_QUADS);
		                glTexCoord2i(0,0);        
		                glVertex3f(0.0,0.0,0.0);
	
 		                glTexCoord2i(1,0);      
 		                glVertex3f(float(gui_tex->getWidth()),0.0,0.0);
        
         		        glTexCoord2i(1,1);                            
         		        glVertex3f(float(gui_tex->getWidth()),float(gui_tex->getHeight()),0.0);
        
                 		glTexCoord2i(0,1);                         
                 		glVertex3f(0.0,float(gui_tex->getHeight()),0.0);
      		    glEnd();
       	glPopMatrix();	    
        gui_tex->resetTexture();        
    }
    
    int isOver( int mx, int my )
    {
        if( (mx > x) && (mx < (x+gui_tex->getWidth())) && (my > y) && (my < (y+gui_tex->getHeight())) )
            return ID;
        else
            return -1;             
    }    
        
};    
    
#endif
