/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */

#include "engine/Ega_Game.h"
#include "menu/Ega_GuiGameMenuManage.h"


Ega_GuiGameMenuManage::Ega_GuiGameMenuManage()
{
    gui_menu = new Ega_GuiGameMenu();
    gui_menu->setGui();
}

Ega_GuiGameMenuManage::~Ega_GuiGameMenuManage()
{
    delete gui_menu;
}    
 
/*bool Ega_GuiMainMenuEvent::pollKeyUp( SDL_keysym* keysym )
{
    return true;
}

bool Ega_GuiMainMenuEvent::pollMouseBoutUp(SDL_MouseButtonEvent* MouseBout)
{
    return true;
} */      
       
bool Ega_GuiGameMenuManage::pollKeyDown( SDL_keysym* keysym )
{   
    switch( keysym->sym ) 
    {
    case SDLK_ESCAPE:
        return false;
        break;
    case SDLK_SPACE:
        Ega_Game::getIt()->play();
        return true;
        break;
    default:
        break;
    }    
    return true;
}

bool Ega_GuiGameMenuManage::pollMouseBoutDown( SDL_MouseButtonEvent* MouseBout )
{   
    event_mouse.Clk_x = event_mouse.Pos_x = MouseBout->x;
    event_mouse.Clk_y = event_mouse.Pos_y = MouseBout->y;
    
    switch( MouseBout->button ) 
    {
    case SDL_BUTTON_LEFT:
        //gui_menu.checkGui(event_mouse.Pos_x, event_mouse.Pos_y);
        return true;
        break;
    case SDL_BUTTON_MIDDLE:
        return true;
        break;
    case SDL_BUTTON_RIGHT:
        return true;
        break;
    default:
        return true;
        break;
    }
    return true;
}

bool Ega_GuiGameMenuManage::pollMouseMotion( SDL_MouseMotionEvent* MouseMov )
{
    event_mouse.Clk_x = event_mouse.Pos_x = MouseMov->x;
    event_mouse.Clk_y = event_mouse.Pos_y = MouseMov->y;
    event_mouse.Mov_x = MouseMov->xrel;
    event_mouse.Mov_y = MouseMov->yrel;  
    
    return true;
}

bool Ega_GuiGameMenuManage::pollAllEvents()
{
    SDL_PumpEvents();
    while( SDL_PollEvent( &event_actual ) ) 
    {
        switch( event_actual.type ) 
        {
        case SDL_KEYDOWN:
                return pollKeyDown( &event_actual.key.keysym );
            break;
        case SDL_MOUSEBUTTONDOWN:
                return pollMouseBoutDown( &event_actual.button );
            break;
        case SDL_MOUSEMOTION:
                return pollMouseMotion( &event_actual.motion );
            break;
        case SDL_QUIT:
                return false;
            break;
        default:
                return true;
            break;
        }
    }
    return true;
}

bool Ega_GuiGameMenuManage::manageGui()
{    
    gui_menu->checkGui(event_mouse.Pos_x, event_mouse.Pos_y);  
    gui_menu->drawGui();
    return pollAllEvents();    
}

