/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */

#ifndef _EGA_GUILABEL_H_
#define _EGA_GUILABEL_H_

#include "Ega_GuiBase.h"
#include "display/Ega_Font.h"
#include <string.h>
#include <stdarg.h>

class Ega_GuiLabel: public Ega_GuiBase
{
public:
    char gui_label[256];   
    Ega_Font *gui_font;
    
    Ega_GuiLabel(int _id, int _x, int _y, Ega_Font *font ):Ega_GuiBase(_id, _x, _y)
    {
        gui_font = font;
    }
        
    virtual ~Ega_GuiLabel()
    {
    }    
     
    void setAndDraw(int isSelectedId, char *txt, ...)
    {
        va_list ap;
        
        if (txt == 0)
            return;
            
       	va_start(ap, txt);
            vsprintf_s(gui_label, txt, ap);
       	va_end(ap);
       	
        draw(isSelectedId);
    }    
     
    void set(char *txt, ...)
    {
        va_list ap;

        if (txt == 0)
            return;
            
       	va_start(ap, txt);
            vsprintf_s(gui_label, txt, ap);
       	va_end(ap);
       		
    }
    
    void draw( int isSelectedId )
    {
        if( ID == isSelectedId )
                gui_font->setColor(Vect4(1.0, 0.0, 0.0, 1.0)); 
        else
                gui_font->setColor(Vect4(1.0, 1.0, 1.0, 1.0)); 
          
        gui_font->print(x, y, gui_label);        
    }  
    
    int isOver( int mx, int my )
    {
        int lenght = strlen(gui_label);
        if( (mx > x) && (mx < (x+10*lenght)) && (my > y) && (my < (y+10)) )
            return ID;
        else
            return -1;             
    }  
        
};    
    
#endif
