/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */

#include "Ega_GuiPanel.h"

/*Ega_GuiPanel::Ega_GuiPanel()
{   
    gui_cptId = 0;
    gui_isSelectedId = -1;
}*/
 
Ega_GuiPanel::Ega_GuiPanel( int _id, int _x, int _y, Ega_Font *font):Ega_GuiBase(_id, _x, _y)
{
    gui_font = font;
    gui_cptId = 0;
    gui_isSelectedId = -1;
}

Ega_GuiPanel::~Ega_GuiPanel()
{
    while( gui_listLabel.size() )
	{
	    delete gui_listLabel.back();
	    gui_listLabel.pop_back();
	}
	while( gui_listButton.size() )
	{
	    delete gui_listButton.back();
	    gui_listButton.pop_back();
	}
}

void Ega_GuiPanel::setFont(Ega_Font *font)
{
    gui_font = font;
}
    
int Ega_GuiPanel::checkGuiPanel( int mx, int my )
{
    for( int i = 0; i < gui_listLabel.size(); i++ )
    {
        gui_isSelectedId = gui_listLabel[i]->isOver( mx, my );
        if( gui_isSelectedId != -1 )
                return gui_isSelectedId;
    } 
    for( int i = 0; i < gui_listButton.size(); i++ )
    {
        gui_isSelectedId = gui_listButton[i]->isOver( mx, my );
        if( gui_isSelectedId != -1 )
                return gui_isSelectedId;
    } 
    return -1;  
}

void Ega_GuiPanel::drawGuiPanel()
{
    for( int i = 0; i < gui_listLabel.size(); i++ )
        gui_listLabel[i]->draw(gui_isSelectedId);
        
    for( int i = 0; i < gui_listButton.size(); i++ )
        gui_listButton[i]->draw(gui_isSelectedId);    
}
       
void Ega_GuiPanel::addLabel( int id, int x, int y, char *txt )
{
    Ega_GuiLabel *label = new Ega_GuiLabel( id, x, y, gui_font );
    label->set( txt );
    gui_listLabel.push_back(label);
    gui_cptId++; 
}

void Ega_GuiPanel::addButton( int id, int x, int y, char *image )
{
    Ega_GuiButton *button = new Ega_GuiButton( id, x, y, image );
    gui_listButton.push_back(button);
    gui_cptId++;             
}

/*
void Ega_GuiPanel::addScrollBar( char *image, int x, int y, int min, int max, int position)
{
    
}    
*/    
