/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */

#ifndef _EGA_GUIPANEL_H_
#define _EGA_GUIPANEL_H_

#include <SDL.h>
#include <gl/gl.h>

#include "display/Ega_Font.h"
#include "ega_GuiBase.h"
#include "menu/Ega_GuiLabel.h"
#include "Ega_GuiButton.h"
//#include "FL_UIScroll.h"
#include <vector>

using namespace std;

class Ega_GuiPanel: public Ega_GuiBase
{
public:
    //Ega_GuiPanel();
    Ega_GuiPanel( int _id, int _x, int _y, Ega_Font *font );
    virtual ~Ega_GuiPanel();
         
    int checkGuiPanel( int mx, int my );
    void drawGuiPanel();
    
    void setFont(Ega_Font *font);
    void addLabel( int id, int x, int y, char *txt );
    void addButton( int id, int x, int y, char *image );
    //void addScrollBar( char *image, int x, int y, int min, int max, int position);
    
private:
       
    Ega_Font *gui_font;
    int gui_cptId;
    int gui_isSelectedId;
    
    vector<Ega_GuiLabel*>  gui_listLabel;
    vector<Ega_GuiButton*> gui_listButton;
    //std::vector<Ega_GuiScrollBar*> gui_listScrollBar;
    //std::vector<Ega_GuiScrollList*> gui_listScrollList;
    
};
    
#endif
