/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */
 
#include "engine/Ega_Scene.h"
#include "other/Ega_Camera.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Ega_Camera::Ega_Camera ()
{
	cam_pos[0]=cam_pos[1]=cam_pos[2]=0.0;
	cam_offset[0]=cam_offset[1]=cam_offset[2]=0.0;
	cam_orient = quaternion( 0.0, Vect3(0.0, 0.0, 0.0));
	
	cam_near = 1.0;
	cam_far = 10000.0;
	cam_far = Ega_Scene::getIt()->getRadiusWorld();
}

Ega_Camera::~Ega_Camera ()
{

}

void Ega_Camera::store()
{
    return Ega_Scene::getIt()->addCamera(this);
}

void Ega_Camera::applyCamera()
{
    /*glMatrixMode(GL_PROJECTION);
    glLoadIdentity ();
	//glFrustum(-1.3, 1.3, -1.0, 1.0, 1.0, 100000.0);
	gluPerspective(60,1.3,1,100000);*/
	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity ();


	Vect3 _v = -cam_orient.getAxis();
 	
 	glTranslated (-cam_offset[0],-cam_offset[1],-cam_offset[2]);
 	glRotated(cam_orient.getAngle(),_v[0],_v[1],_v[2]);
	glTranslated ( -cam_pos[0],-cam_pos[1],-cam_pos[2]);   
}

void Ega_Camera::setPos(Vect3 _pos)
{
	cam_pos[0] = _pos[0];
	cam_pos[1] = _pos[1];
	cam_pos[2] = _pos[2];
}

void Ega_Camera::setOrient(quaternion _orient)
{
	cam_orient = _orient;
}

void Ega_Camera::setOffset(Vect3 _ofs)
{
    cam_offset = _ofs;
}    

void Ega_Camera::changePos(Vect3 _dpos)
{
	cam_pos[0] += _dpos[0];
	cam_pos[1] += _dpos[1];
	cam_pos[2] += _dpos[2];
}

void Ega_Camera::changeOrient(quaternion _dorient)
{
	cam_orient = cam_orient * _dorient ;
}

void Ega_Camera::changeOffset(Vect3 _dofs)
{
    cam_offset += _dofs;
}    

void Ega_Camera::setNearPlan( GLdouble _np )
{
    cam_near = _np;
}    

void Ega_Camera::setFarPlan( GLdouble _fp )
{
    cam_far =_fp;
}    

void Ega_Camera::setFovy( GLdouble _fovy )
{
    cam_fovy = _fovy;
}    
