/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */


/* Description du fichier :
 *
 * description de la classe Fl_Camera
 * !! ne drive pas de la classe Fl_Entite
 */

#ifndef _EGA_CAMERA_H_
#define _EGA_CAMERA_H_

#include "tool/Ega_Tools.h"
#include <gl/gl.h>

class Ega_Camera  
{
public:
    Ega_Camera ();
	virtual ~Ega_Camera ();
	
    void store();
	void setPos(Vect3 _pos);
	void setOrient(quaternion _orient);
	void setOffset(Vect3 _ofs);
	void setNearPlan( GLdouble _np );
	void setFarPlan( GLdouble _fp );
	void setFovy( GLdouble _fovy );
	
	void changePos(Vect3 _dpos);
	void changeOrient(quaternion _dorient);
	void changeOffset(Vect3 _dofs);
	void applyCamera();

private:
	Vect3 cam_pos;
    Vect3 cam_offset;
	quaternion cam_orient;
	
	GLdouble cam_near;
	GLdouble cam_far;
	GLdouble cam_fovy;
};

#endif
