/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */

/* 
 * srie de macros pour gerer le debug;
 * Ce fichier dfinie une srie de macro pour le dbuggage
 * En fonction des valeurs de D_**** les messages de dbug correspondant
 * sont pris en compte ou non
 *
 * @author Matthieu Gautier
 */

#ifndef _DEBUG_H_
#define _DEBUG_H_

#define D_ALL 1 // si a 0 : aucun message de dbug
 #define D_DISPLAY 1
 #define D_PHYSIC 1
 #define D_PARTICULE 1
 #define D_GAME 1
 #define D_LOADER 1
 #define D_VIDEO 1
 #define D_SOUND 1

#if (D_ALL==1)

 #if (D_DISPLAY==1)
  #define PRINT_DISPLAY1(X) fprintf(stderr,"DISPLAY:\t");fprintf(stderr,X)
  #define PRINT_DISPLAY2(X,Y)  fprintf(stderr,"DISPLAY:\t");fprintf(stderr,X,Y)
 #else
  #define PRINT_DISPLAY1(X) // ici PRINT_DISPLAY1 est dfinie mais ne correspond a rien
  #define PRINT_DISPLAY2(X,Y) // la "ligne" est supprimer ds le code
 #endif // D_DISPLAY
 #if (D_PHYSIC==1)
  #define PRINT_PHYSIC1(X) fprintf(stderr,"PHYSIC:\t");fprintf(stderr,X)
  #define PRINT_PHYSIC2(X,Y) fprintf(stderr,"PHYSIC:\t");fprintf(stderr,X,Y)
 #else
  #define PRINT_PHYSIC1(X) 
  #define PRINT_PHYSIC2(X,Y)
 #endif // D_PHYSIC
 #if (D_PARTICULE==1)
  #define PRINT_PARTICULE1(X) fprintf(stderr,"PARTICULE:\t");fprintf(stderr,X)
  #define PRINT_PARTICULE2(X,Y) fprintf(stderr,"PARTICULE:\t");fprintf(stderr,X,Y)
 #else
  #define PRINT_PARTICULE1(X) 
  #define PRINT_PARTICULE2(X,Y) 
 #endif // D_PARTICULE
 #if (D_GAME==1)
  #define PRINT_GAME1(X) fprintf(stderr,"GAME:\t");fprintf(stderr,X) 
  #define PRINT_GAME2(X,Y) fprintf(stderr,"GAME:\t");fprintf(stderr,X,Y)
 #else
  #define PRINT_GAME1(X)
  #define PRINT_GAME2(X,Y) 
 #endif // D_GAME
 #if (D_LOADER==1)
  #define PRINT_LOADER1(X) fprintf(stderr,"LOADER:\t");fprintf(stderr,X)
  #define PRINT_LOADER2(X,Y) fprintf(stderr,"LOADER:\t");fprintf(stderr,X,Y) 
 #else
  #define PRINT_LOADER1(X)
  #define PRINT_LOADER2(X,Y)
 #endif // D_LOADER
 #if (D_VIDEO==1)
  #define PRINT_VIDEO1(X) fprintf(stderr,"VIDEO:\t");fprintf(stderr,X) 
  #define PRINT_VIDEO2(X,Y) fprintf(stderr,"VIDEO:\t");fprintf(stderr,X,Y) 
 #else
  #define PRINT_VIDEO1(X)
  #define PRINT_VIDEO2(X,Y)
 #endif // D_VIDEO
 #if (D_SOUND==1)
  #define PRINT_SOUND1(X) fprintf(stderr,"SOUND:\t");fprintf(stderr,X)
  #define PRINT_SOUND2(X,Y) fprintf(stderr,"SOUND:\t");fprintf(stderr,X,Y) 
 #else
  #define PRINT_SOUND1(X)
  #define PRINT_SOUND2(X,Y)
 #endif // D_SOUND

#else

 #define PRINT_DISPLAY1(X)
 #define PRINT_DISPLAY2(X,Y)
 #define PRINT_PHYSIC1(X)
 #define PRINT_PHYSIC2(X,Y)
 #define PRINT_PARTICULE1(X)
 #define PRINT_PARTICULE2(X,Y)
 #define PRINT_GAME1(X)
 #define PRINT_GAME2(X,Y) 
 #define PRINT_LOADER1(X)
 #define PRINT_LOADER2(X,Y)
 #define PRINT_VIDEO1(X)
 #define PRINT_VIDEO2(X,Y)
 #define PRINT_SOUND1(X)
 #define PRINT_SOUND2(X,Y)

#endif // D_ALL

#endif // _DEBUG_H_
