/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */

#include "SDL_mixer.h"
#include "Ega_Sound.h"

#include "other/Ega_debug.h"


Ega_Sound::Ega_Sound(char* audioFileName){
    sou_audioFileName = audioFileName;
    openAudioFile(audioFileName);
}    

Ega_Sound:: ~Ega_Sound(){}
//Ouverture d'un fichier de musique
Mix_Music* Ega_Sound::openAudioFile(char* audioFileName){
    Mix_Music *music;
    music=Mix_LoadMUS(audioFileName);
    if(!music) {
        PRINT_SOUND2("Mix_LoadMUS(\"music.mp3\"): %s\n", Mix_GetError());
            // this might be a critical error...
    } 
    return music;
}

void Ega_Sound::readAudioFile(char* audioFileName, int loop){
        Mix_Music *music;
        music = openAudioFile(audioFileName);
        // Mix_Music *music; // I assume this has been loaded already
        if(Mix_PlayMusic(music, loop)==-1) {
        PRINT_SOUND2("Mix_PlayMusic: %s\n", Mix_GetError());
        // well, theres no music, but most games dont break without music...
        } 
}

void Ega_Sound::closeAudioFile(char* audioFileName){
    Mix_Music *music;
    music = openAudioFile(audioFileName);
    Mix_FreeMusic(music);
    music = NULL;
}

void Ega_Sound::volumeControl(int volume){
// set channel 1 to half volume
    Mix_VolumeMusic(volume); 
}

    
