/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */

#ifndef _MATRICE_H_
#define _MATRICE_H_

template<int N,int M=N,class T=float>
class matrice
{
public:
	T tab[N][M];
	
	matrice();
	~matrice();
	
	matrice<N,M,T> operator-();
	matrice<N,M,T> operator+(matrice<N,M,T> _other);
	matrice<N,M,T> operator-(matrice<N,M,T> _other);
	matrice<N,M,T> operator*(matrice<N,M,T> _other);  // multiplie membre a membre
	matrice<N,M,T> operator*(T _other);
	template<int L>
	matrice<N,M,T> operator^(matrice<M,L,T> _other);  // multiplie "mathmatiquement" les matrices
	
	matrice<N,M,T> operator~(); // inverse
	
	matrice<N,M,T> operator+=(matrice<N,M,T> _other);
	matrice<N,M,T> operator-=(matrice<N,M,T> _other);
	matrice<N,M,T> operator*=(matrice<N,M,T> _other);  // multiplie membre a membre
	matrice<N,M,T> operator*=(T _other);
	template<int L>
	matrice<N,M,T> operator^=(matrice<M,L,T> _other);  // multiplie "mathmatiquement" les matrices
	
	matrice<N,M,T> operator=(matrice<N,M,T> _other); // inverse
	
	bool operator==(matrice<N,M,T> _other);
	bool operator!=(matrice<N,M,T> _other);
	
	matrice<M,N,T> transpose();
	
	T** operator() ();
	

};

#include "Ega_Matrice.imp"

#endif //_MATRICE_H_
