/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */
 
 
#ifndef _EGA_QUATERNION_H_
#define _EGA_QUATERNION_H_

#include "tool/Ega_Vecteur.h"
#include <math.h>
#include <stdio.h>

class quaternion
{
public:
    
    quaternion();
    quaternion(Vect3 _axe);
    quaternion(float _angle, Vect3 _axe);
    quaternion(Vect3 _orig, Vect3 _dest);
    quaternion(const quaternion &_quat);
    
    void setAngle(float _angle);
    void setAxis(Vect3 _axe);
    void changeAngle(float _dangle);
    
    quaternion operator+(quaternion _q);
    quaternion operator-(quaternion _q);
    quaternion operator*(quaternion _q);
    quaternion operator*(float _f);
    quaternion operator~();
    
    quaternion operator=(quaternion _q);
    
    friend Vect3 rotate(Vect3 _v3,quaternion _q);
    
    
    float getAngle();
    Vect3 getAxis();
    
    
//private:
    float m_val;
    Vect3 m_axe;

    void normalise();
};

#endif // _QUATERNION_H_
