/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */


/* Description du fichier :
 *
 *  descrit divers constante
 * ?? a fusionner avec main.h ??
 */


#ifndef _EGA_TOOLS_H_
#define _EGA_TOOLS_H_

#include <vector>
#include <string>
#include "tool/Ega_Vecteur.h"
#include "tool/Ega_Quaternion.h"
#include <gl/gl.h>

using namespace std ;

#define POINT_CONTACT 10

struct force
{
    Vect4 pos;
    int intensite;
    int decroissement;
};

struct contact
{
  Vect3 pos;
  Vect3 normal;
  double depth;
};

struct collision
{
  contact _contact[POINT_CONTACT];
  int Id1,Id2;
  Vect3 vit1,vit2;
  Vect3 pos1,pos2;
  quaternion rot1,rot2;  
  int nbContact;
};   

struct face
{
	int v1, v2, v3;
	face(int _v1, int _v2, int _v3)
	{
	    v1 = _v1; v2 = _v2; v3 = _v3;
    }    
};

struct animation
{
    Vect3    aPos;
    Vect3    aScal;
    quaternion  aRot;
};

//typedef GLfloat * Fl_Color

float rd(float range);

float * vect4TOfloat(Vect4 a, float color[4]);
float * vect3TOfloat(Vect3 a, float color[3]);

int string2int(string _string);
double string2double(string _string);

#endif
