/*
 * Copyright (C) 2005  ENSI-GAME-ART
 *
 * Club ENSI-GAME-ART ENSICAEN
 * 6 Boulevard Marechal Juin
 * F-14050 Caen Cedex
 *
 * Ce fichier est l'oeuvre d'eleves de l'ENSI de Caen. Il est developp
 * sous la licence GPL :
 *
 ****************************************************************
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *****************************************************************
 *
 * Ce fichier fait partie du projet de jeu video de course spatiale
 * developpe au sein du club ENSI-GAME-ART
 */

#ifndef _EGA_VECTEUR_H_
#define _EGA_VECTEUR_H_

#include "Ega_Exeption.h"
#include "stdio.h"


/**
 * Template for a N dimensionnal vector of T type.
 * 
 *
 * @author	Matthieu Gautier
 * @version 2
 */
template<class T, int N >
class Vect
{
public :
	T tab[N];
	//constructor
	Vect ();
   // Vect (T valeur);
    Vect (T valeur1, T valeur2);
    Vect (T valeur1, T vameur2, T valeur3);
    Vect (T valeur1, T vameur2, T valeur3, T valeur4);
    Vect (T _val[N]);
    Vect (const Vect<T,N> & _val);
    
    
    //operator accesseur
    T& operator[] ( char  _index); //acces a un membre a la faon des tableau
    
    
    //operateur "operation"
    Vect<T,N> operator- (); //retourne l'opposer de chaque membre
    Vect<T,N> operator+ (Vect<T,N> _v); // additione 2 Vect (commutatif)
    Vect<T,N> operator- (Vect<T,N> _v); // soustrai 2 Vect (non commutatif)
    Vect<T,N> operator* (Vect<T,N> _v); // multiplie membre  membre 2 Vect (commutatif)
    Vect<T,N> operator* (T _v);
    T   operator% (Vect<T,N> _v); // effectue le produirs scalaire de 2 Vect (commutatif)
    Vect<T,N> operator/ ( Vect<T,N> _v); // divise membre  membre 2 Vect (non commutatif)
    Vect<T,N> operator/	(T _v);
    Vect<T,N> operator^ (Vect<T,N> _v); // effectue le produit vectoriel de 2 Vect (non commutatif)

    
    //operateur "modification"
    Vect<T,N> operator+= (Vect<T,N> _v); // additione le 2eme Vect au 1er
    Vect<T,N> operator-= (Vect<T,N> _v); // soustraie le 2eme Vect au 1er
    Vect<T,N> operator*= (Vect<T,N> _v); // multiplie membre  membre le 2eme Vect au 1er
    Vect<T,N> operator*= (T _v); // multiplie membre  membre le 2eme Vect au 1er
    Vect<T,N> operator/= (Vect<T,N> _v); // divise membre  membre le 1er Vect par le 2eme
    Vect<T,N> operator/= (T _v); // divise membre  membre le 1er Vect par le 2eme
    Vect<T,N> operator^= (Vect<T,N> _v); // effectue le produit vectoriel de 2 Vect (non commutatif)
    
    
    //operateur  d'affectation
    Vect<T,N> operator= ( const Vect<T,N> _v); 
    
    
    //operateur de comparaison
    bool operator< (Vect<T,N> _v); // compare les normes
    bool operator>= (Vect<T,N> _v);
    bool operator> (Vect<T,N> _v);
    bool operator<= (Vect<T,N> _v);
    bool operator<< (Vect<T,N> _v); // compare reciproquement les membres des Vects
    bool operator>> (Vect<T,N> _v);
    bool operator== (Vect<T,N> _v); // compare les membres
    bool operator!= (Vect<T,N> _v);
    
    
    //methode public
    float norme(); // retroune la norme du Vect
    void normalise(); // normalise le Vect
    Vect<T,N> normalized(); // retourne le Vect normalis mais ne modif pas celui d'origine
};
 

template <class T, int N> float normeProjec(Vect<T,N> _vect, Vect<T,N> _sur);



template <class T, int N> Vect<T,N> projec(Vect<T,N> _vect, Vect<T,N> _sur);

#include "Ega_vecteur.imp"

typedef Vect<float,2> Vect2;
typedef Vect<float,3> Vect3;
typedef Vect<float,4> Vect4;

#endif
